#define ANI_AVATAR		1
#define ANI_PHANTOM		2
#define ANI_PARTICLE  3
#define ANI_BUBBLE		5
#define ANI_TRIANGLE	6
#define ANI_MUSTANG		10
#define ANI_DINGHY    11
#define ANI_CESSNA		12
#define ANI_VOYAGER   13
#define ANI_GROUND    20
#define ANI_FLUID     21
#define ANI_SHAPE     99

#define ANI_INAIR     1
#define ANI_INFLUID		2
#define ANI_ONGROUND  4


#define ANI_AUX_AVERAGE 1

class animated {
	public:
		animated(void);
		virtual ~animated(void);
		virtual void control(bool human)=0;
		virtual void draw(bool human)=0;		
		void vicinity(void);			//update node in geometry graph
		void auxiliary(int opt);
		void motion(void);
		void listener(void);
		matrix<float> getMat(void); //needs to be computed due to animated* carrier
		void setMat(matrix<float>& wmat);
		void independent(void);
		void displayBound(void);	//rename later because is displays connectivity too	
		void setMassAndG(float m,float g) {G=m*g; if (m) oomass=1/m; else oomass=0;} //HELLO, why 1 ????
		void initBound(float bx,float by,float bz);		
		float evalBound(matrix<float> pnt);
		int index;								//type of animated and properties
		matrix<float> *mat;				//4x4 objects state matrix (important)				
		matrix<float> *tforce,*tvel,*tfric; //translation world
		matrix<float> *rforce,*rvel,*rfric; //rotation    object
		matrix<float> *oforce,      *ofric; //translation object
		long time[4];							//birth | death | reserved(:PHANTOM)		
		float oomass,G;						//1/mass,friction is tensor,gravity,hits is number of collision
		matrix<float> *bound;			//ellipsoid coefficients =[1/r1^2 1/r2^2 1/r3^2]
		animated *carrier;						//arbitrary attachment
		ntree<animated*> *node;		//NULL closest		
		int medium,channel;				//hardest medium of contact/sound channel
		float hits;
};
//definitions------------------------
ntree<animated*> *ntree_ani;
//contructors------------------------
matrix<float> animated::getMat(void) {//nicea eleganca codea!
	matrix<float> A=*mat;
	animated* ani=this;
	while (ani=(animated*)ani->carrier) A=*ani->mat*A;
	return A;
}
void animated::setMat(matrix<float>& wmat) {
	*mat=matrix<float>(4,4,"eye");
	*mat=getMat().glInverse()*wmat;
};
void animated::independent(void) {
	*mat=getMat();
	carrier=NULL;
}

animated::animated(void) {
	mat=new matrix<float>(4,4,"eye");
	tforce=new matrix<float>(4,1,"");			//in world
	tvel  =new matrix<float>(4,1,"");
	tfric =new matrix<float>(4,1,"");
	rforce=new matrix<float>(4,1,"");			//in object
	rvel  =new matrix<float>(4,1,"");
	rfric =new matrix<float>(4,1,"ones");
	oforce=new matrix<float>(4,1,"");			//in world
	ofric =new matrix<float>(4,1,"ones");
	time[0]=toc;			 				//birth time
	time[1]=toc+3600000;			//planned death
	time[2]=toc;
	oomass=1; G=0;						//1/mass | friction | gravity
	bound=NULL;	
	carrier=NULL;
	node=NULL;								//the closest solid node
	medium=ANI_INAIR;
	channel=0;
	hits=0;
};
animated::~animated(void) {
	delete mat;
	delete tforce; delete tvel; delete tfric;
	delete rforce; delete rvel; delete rfric;
	delete oforce; 
	delete bound;
};
//virtual funcs-----------
//common------------------
void animated::vicinity(void) {
	if (!node) node=ntree_ani; //put in CONSTRUCTOR of ani!!! ???
	matrix<float> pst(3,1,""); memcpy(pst.data,&mat->data[12]            ,12);
	matrix<float> psn(3,1,""); memcpy(psn.data,&node->data->mat->data[12],12);	
	float min_val=(pst-psn).norm(2);
	for (int c1=0;c1<node->ary;c1++) {
		if (node->next[c1]) {
			memcpy(psn.data,&node->next[c1]->data->mat->data[12],12);
				if ((pst-psn).norm(2)<min_val) {node=node->next[c1]; break;}
		} else break;
	}
};
void animated::auxiliary(int opt) {
	if (opt==ANI_AUX_AVERAGE)
		if (hits) {//collisions have taken place
			if (hits>.0001) {
				float f=1/hits;
				*tforce*=f;				
				*rforce*=f;
				*tfric*=f;
			} else {							
				memcpy(tforce->data,zeros_float,16);
				memcpy(rforce->data,zeros_float,16);
				memcpy( tfric->data,zeros_float,16);
			}
			hits=0;
		}
}

void animated::motion(void) {//translation&spin
	if (index==ANI_PARTICLE) {
		dt=.01;
		ofric->data[0]=2.5;
		ofric->data[1]=2.5;
		ofric->data[2]=2.5;
	}
	tforce->data[1]+=G;
	*tforce+=*mat**oforce;
#ifndef ANI_DELAY
	*tvel+=*tforce*(oomass*dt)-((tfric->diag()+*mat*ofric->diag()*mat->glInverse())*dt)**tvel;
	for (int c1=0;c1<3;c1++) mat->data[12+c1]+=tvel->data[c1]*dt; //t in world	
#else
	for (int c1=0;c1<3;c1++) mat->data[12+c1]+=tvel->data[c1]*dt; //t in world	
	*tvel+=*tforce*(oomass*dt)-((tfric->diag()+*mat*ofric->diag()*mat->glInverse())*dt)**tvel;
#endif
	*rvel=*rvel%(*rfric*(-dt)+1)+*rforce*(oomass*dt); //INERTIA!!!
	matrix<float> rdel=*rvel*dt;
	*mat*=glRotation(rdel.data);                      //r in obj
	memcpy(tforce->data,zeros_float,16);//set vals for next iteration
	memcpy(rforce->data,zeros_float,16);
	memcpy(oforce->data,zeros_float,16);
	memcpy( tfric->data,zeros_float,16);
	medium=ANI_INAIR;
};

void animated::listener(void) {
	FSOUND_3D_Listener_SetAttributes(&mat->data[12],tvel->data,
	mat->data[8],mat->data[9],mat->data[10],
	mat->data[4],mat->data[5],mat->data[6]);
}

void animated::displayBound(void) {
	int c1;
	if (bound) {
		matrix<float> d=*bound;	
		d/=1; d.apply(sqrt);
		glPushMatrix();
			glMultMatrixf(mat->data);
			glLineWidth(1);
			glColor3f(.5,.5,.5);			
			glScalef(d.data[0],d.data[1],d.data[2]);
			glutWireSphere(1.02,10,10);
		glPopMatrix();
	}
	if (node) {
		glPushMatrix();
			glEnable(GL_LINE_STIPPLE);
			glLineStipple(1,0xAAAA);
			glBegin(GL_LINES);
			glNormal3f(0,1,0);
			glColor3f(1,1,1); glVertex3fv(&mat->data[12]);
			glColor3f(0,0,0); glVertex3fv(&node->data->mat->data[12]);			
			for (c1=0;c1<node->ary;c1++)
				if (node->next[c1]) {
					glColor3f(1,0,0); glVertex3fv(&mat->data[12]);
					glColor3f(0,0,1); glVertex3fv(&node->next[c1]->data->mat->data[12]);}
				else break;			
			glEnd();
			glDisable(GL_LINE_STIPPLE);
		glPopMatrix();
	}
};
void animated::initBound(float bx,float by,float bz) {
	bound=new matrix<float>(1,3,"");
 	bound->data[0]=1/(bx*bx);
 	bound->data[1]=1/(by*by);
 	bound->data[2]=1/(bz*bz);
};
float animated::evalBound(matrix<float> pnt) {
	pnt.numel=3; pnt%=pnt; return (pnt|*bound);
};
//------------------------------------------------------------------------
class avatar : public animated {public:
	avatar(void);
	void control(bool human);
	void draw(bool human);
};
avatar::avatar(void) : animated() {
	index=ANI_AVATAR;	
	*tfric*=1;
	ofric->data[0]=5;
	ofric->data[1]=5;
	ofric->data[2]=2;
	*rfric*=5;
};
void avatar::control(bool human) {
	if (human) {
		oforce->data[0]=(keys.data[KEY_SP+102]-keys.data[KEY_SP+100])*50;
		oforce->data[1]=(keys.data[KEY_SP+104]-keys.data[KEY_SP+105])*50;
		oforce->data[2]=(keys.data[KEY_SP+103]-keys.data[KEY_SP+101])*20;
		rforce->data[0]-=mouse[0]; mouse[0]=0;
		rforce->data[1]-=mouse[1]; mouse[1]=0;
		rforce->data[2]+=(keys.data[KEY_SP+108]-keys.data[KEY_SP+106])*10;
	}
};
void avatar::draw(bool human) {
	if (!human) {glColor3f(1,1,1); glutSolidSphere(.1,10,10); }
};
//
class particle : public animated {
	public:
		particle(void) : animated() {index=ANI_PARTICLE;}
		particle(float *p) : animated() {index=ANI_PARTICLE; memcpy(&mat->data[12],p,12);};
		void control(bool human) {};
		void draw(bool human) {};
};
void drawShape(matrix<float> &shp);
class myShape : public animated {
	public:
		myShape(matrix<float> shp) : animated() {index=ANI_SHAPE; shape=new matrix<float>(); *shape=shp;};
		void control(bool human) {};
		void draw(bool human) {drawShape(*shape);};
	matrix<float> *shape;
};


#define ANI_SYSTEM_ROT_X 				1  //are not yet implemented all!!!
#define ANI_SYSTEM_ROT_Y 				2
#define ANI_SYSTEM_ROT_Z 				4
#define ANI_SYSTEM_ROT_3D 			7
#define ANI_SYSTEM_TRANSL_X 		8
#define ANI_SYSTEM_TRANSL_Y 		16
#define ANI_SYSTEM_TRANSL_Z 		32
#define ANI_SYSTEM_TRANSL_3D		56
#define ANI_SYSTEM_6DOF         63

unsigned int system_hnd[1];	//drawList

void ani_systems(void) {	
	system_hnd[0]=newList(glGenLists(1),"data\\halfcir",0,matrix<float>(4,4,"eye"));
};

void ani_system_arrow(int cone) {
	glScalef(.05,.05,1);
	glTranslatef(0,0,.4);	glutSolidCube(.8);
	if (cone) {glTranslatef(0,0,.4); glutSolidCone(3,.2,12,4); }
};
void ani_system_draw(int opt) {
	glPushMatrix(); glColor3f(1,0,0); glRotatef(90,0,1,0); 	ani_system_arrow(opt&ANI_SYSTEM_TRANSL_X); glPopMatrix();
	glPushMatrix(); glColor3f(0,1,0); glRotatef(90,-1,0,0); ani_system_arrow(opt&ANI_SYSTEM_TRANSL_Y); glPopMatrix();
	glPushMatrix(); glColor3f(0,0,1); 											ani_system_arrow(opt&ANI_SYSTEM_TRANSL_Z); glPopMatrix();
	if (opt&ANI_SYSTEM_ROT_X) glCallList(system_hnd[0]);			
	if (opt&ANI_SYSTEM_ROT_Y) {
		glPushMatrix();
			glRotatef(90,0,0,1);
			glCallList(system_hnd[0]);
		glPopMatrix();
	}
	if (opt&ANI_SYSTEM_ROT_Z) {
		glPushMatrix();
			glRotatef(90,0,1,0);
			glCallList(system_hnd[0]);
		glPopMatrix();
	}
	glColor3f(.8,.8,.8); glutSolidCube(.2);	
};


class ani_system : public animated {
	public:
		ani_system(void) : animated() {opt=0;};
		void apply(matrix<float> &wmat);
		void control(bool human) {};
		void draw(bool human) {
			glPushMatrix();
				if (carrier) {//draws line
					glMultMatrixf(carrier->getMat().data);
					glBegin(GL_LINES);
						glVertex3fv(zeros_float);
						glVertex3fv(&mat->data[12]);
					glEnd();
					if (!((ani_system*)carrier)->opt) independent();
				}
				glMultMatrixf(mat->data);
				ani_system_draw(opt);
			glPopMatrix();			
		};
		int opt;
};
void ani_system::apply(matrix<float> &wmat) {
	matrix<float> take(4,4,"eye");
	//id=DOM_6DOF;
	if (opt&ANI_SYSTEM_TRANSL_X) take.data[12]=wmat.data[12];
	if (opt&ANI_SYSTEM_TRANSL_Y) take.data[13]=wmat.data[13];
	if (opt&ANI_SYSTEM_TRANSL_Z) take.data[14]=wmat.data[14];
	if ((opt&ANI_SYSTEM_ROT_3D)==ANI_SYSTEM_ROT_3D) memcpy(take.data,wmat.data,48);
	else { //later use code that uses more sophistic. projections!!! to enable Euler :-(
		matrix<float> nrm(3,1,"");
		if (opt&ANI_SYSTEM_ROT_X) {
			memcpy(nrm.data,&take.data[4],12);
			nrm.data[0]=0; nrm.normalize();
			memcpy(&take.data[4],nrm.data,12);
			take.data[ 9]=-take.data[6]; take.data[10]= take.data[5];
		}
		if (opt&ANI_SYSTEM_ROT_Z) {
			memcpy(nrm.data,take.data,12);
			nrm.data[2]=0; nrm.normalize();
			memcpy(take.data,nrm.data,12);
			take.data[ 4]=-take.data[1]; take.data[5]= take.data[0];
		}
	}
	*mat=*mat*take;	
	glPushMatrix();
		glMultMatrixf(take.data);
		glCallList(hnd_coord);
	glPopMatrix();
}