#define ANI_AVATAR		1
#define ANI_PHANTOM		2
#define ANI_PARTICLE  3
#define ANI_BUBBLE		5
#define ANI_TRIANGLE	6
#define ANI_MUSTANG		10
#define ANI_DINGHY    11
#define ANI_CESSNA		12
#define ANI_VOYAGER   13
#define ANI_GROUND    20
#define ANI_FLUID     21
#define ANI_SHAPE     99

#define ANI_INAIR     1
#define ANI_INFLUID		2
#define ANI_ONGROUND  4


#define ANI_AUX_AVERAGE 1

class animated {
	public:
		animated(void);
		virtual ~animated(void);
		virtual void control(bool human)=0;
		virtual void draw(bool human)=0;		
		void vicinity(void);			//update node in geometry graph
		void auxiliary(int opt);
		void motion(void);
		void listener(void);
		matrix<float> getMat(void); //needs to be computed due to animated* carrier
		void displayBound(void);	//rename later because is displays connectivity too	
		void setMassAndG(float m,float g) {G=m*g; if (m) oomass=1/m; else oomass=0;} //HELLO, why 1 ????
		void initBound(float bx,float by,float bz);		
		float evalBound(matrix<float> pnt);
		int index;								//type of animated and properties
		matrix<float> *mat;				//4x4 objects state matrix (important)				
		matrix<float> *tforce,*tvel,*tfric; //translation world
		matrix<float> *rforce,*rvel,*rfric; //rotation    object
		matrix<float> *oforce,      *ofric; //translation object
		long time[4];							//birth | death | reserved(:PHANTOM)		
		float oomass,G;						//1/mass,friction is tensor,gravity,hits is number of collision
		matrix<float> *bound;			//ellipsoid coefficients =[1/r1^2 1/r2^2 1/r3^2]
		void *carrier;						//arbitrary attachment
		ntree<animated*> *node;		//NULL closest		
		int medium,channel;				//hardest medium of contact/sound channel
		float hits;
};
//definitions------------------------
ntree<animated*> *ntree_ani;
//contructors------------------------
matrix<float> animated::getMat(void) {//nicea eleganca codea!
	matrix<float> A=*mat;
	animated* ani=this;
	while (ani=(animated*)ani->carrier) A=*ani->mat*A;
	return A;
}
animated::animated(void) {
	mat=new matrix<float>(4,4,"eye");
	tforce=new matrix<float>(4,1,"");			//in world
	tvel  =new matrix<float>(4,1,"");
	tfric =new matrix<float>(4,1,"");
	rforce=new matrix<float>(4,1,"");			//in object
	rvel  =new matrix<float>(4,1,"");
	rfric =new matrix<float>(4,1,"ones");
	oforce=new matrix<float>(4,1,"");			//in world
	ofric =new matrix<float>(4,1,"ones");
	time[0]=toc;			 				//birth time
	time[1]=toc+3600000;			//planned death
	time[2]=toc;
	oomass=1; G=0;						//1/mass | friction | gravity
	bound=NULL;	
	carrier=NULL;
	node=NULL;								//the closest solid node
	medium=ANI_INAIR;
	channel=0;
	hits=0;
};
animated::~animated(void) {
	delete mat;
	delete tforce; delete tvel; delete tfric;
	delete rforce; delete rvel; delete rfric;
	delete oforce; 
	delete bound;
};
//virtual funcs-----------
//common------------------
void animated::vicinity(void) {
	if (!node) node=ntree_ani; //put in CONSTRUCTOR of ani!!! ???
	matrix<float> pst(3,1,""); memcpy(pst.data,&mat->data[12]            ,12);
	matrix<float> psn(3,1,""); memcpy(psn.data,&node->data->mat->data[12],12);	
	float min_val=(pst-psn).norm(2);
	for (int c1=0;c1<node->ary;c1++) {
		if (node->next[c1]) {
			memcpy(psn.data,&node->next[c1]->data->mat->data[12],12);
				if ((pst-psn).norm(2)<min_val) {node=node->next[c1]; break;}
		} else break;
	}
};
void animated::auxiliary(int opt) {
	if (opt==ANI_AUX_AVERAGE)
		if (hits) {//collisions have taken place
			if (hits>.0001) {
				float f=1/hits;
				*tforce*=f;				
				*rforce*=f;
				*tfric*=f;
			} else {							
				memcpy(tforce->data,zeros_float,16);
				memcpy(rforce->data,zeros_float,16);
				memcpy( tfric->data,zeros_float,16);
			}
			hits=0;
		}
}

void animated::motion(void) {//translation&spin
	if (index==ANI_PARTICLE) {
		dt=.01;
		ofric->data[0]=2.5;
		ofric->data[1]=2.5;
		ofric->data[2]=2.5;
	}
	tforce->data[1]+=G;
	*tforce+=*mat**oforce;
#ifndef ANI_DELAY
	*tvel+=*tforce*(oomass*dt)-((tfric->diag()+*mat*ofric->diag()*mat->glInverse())*dt)**tvel;
	for (int c1=0;c1<3;c1++) mat->data[12+c1]+=tvel->data[c1]*dt; //t in world	
#else
	for (int c1=0;c1<3;c1++) mat->data[12+c1]+=tvel->data[c1]*dt; //t in world	
	*tvel+=*tforce*(oomass*dt)-((tfric->diag()+*mat*ofric->diag()*mat->glInverse())*dt)**tvel;
#endif
	*rvel=*rvel%(*rfric*(-dt)+1)+*rforce*(oomass*dt); //INERTIA!!!
	matrix<float> rdel=*rvel*dt;
	*mat*=glRotation(rdel.data);                      //r in obj
	memcpy(tforce->data,zeros_float,16);//set vals for next iteration
	memcpy(rforce->data,zeros_float,16);
	memcpy(oforce->data,zeros_float,16);
	memcpy( tfric->data,zeros_float,16);
	medium=ANI_INAIR;
};

void animated::listener(void) {
	FSOUND_3D_Listener_SetAttributes(&mat->data[12],tvel->data,
	mat->data[8],mat->data[9],mat->data[10],
	mat->data[4],mat->data[5],mat->data[6]);
}

void animated::displayBound(void) {
	int c1;
	if (bound) {
		matrix<float> d=*bound;	
		d/=1; d.apply(sqrt);
		glPushMatrix();
			glMultMatrixf(mat->data);
			glLineWidth(1);
			glColor3f(.5,.5,.5);			
			glScalef(d.data[0],d.data[1],d.data[2]);
			glutWireSphere(1.02,10,10);
		glPopMatrix();
	}
	if (node) {
		glPushMatrix();
			glEnable(GL_LINE_STIPPLE);
			glLineStipple(1,0xAAAA);
			glBegin(GL_LINES);
			glNormal3f(0,1,0);
			glColor3f(1,1,1); glVertex3fv(&mat->data[12]);
			glColor3f(0,0,0); glVertex3fv(&node->data->mat->data[12]);			
			for (c1=0;c1<node->ary;c1++)
				if (node->next[c1]) {
					glColor3f(1,0,0); glVertex3fv(&mat->data[12]);
					glColor3f(0,0,1); glVertex3fv(&node->next[c1]->data->mat->data[12]);}
				else break;			
			glEnd();
			glDisable(GL_LINE_STIPPLE);
		glPopMatrix();
	}
};
void animated::initBound(float bx,float by,float bz) {
	bound=new matrix<float>(1,3,"");
 	bound->data[0]=1/(bx*bx);
 	bound->data[1]=1/(by*by);
 	bound->data[2]=1/(bz*bz);
};
float animated::evalBound(matrix<float> pnt) {
	pnt.numel=3; pnt%=pnt; return (pnt|*bound);
};
//------------------------------------------------------------------------
class avatar : public animated {public:
	avatar(void);
	void control(bool human);
	void draw(bool human);
};
avatar::avatar(void) : animated() {
	index=ANI_AVATAR;	
	*tfric*=1;
	ofric->data[0]=5;
	ofric->data[1]=5;
	ofric->data[2]=2;
	*rfric*=5;
};
void avatar::control(bool human) {
	if (human) {
		oforce->data[0]=(keys.data[KEY_SP+102]-keys.data[KEY_SP+100])*50;
		oforce->data[1]=(keys.data[KEY_SP+104]-keys.data[KEY_SP+105])*50;
		oforce->data[2]=(keys.data[KEY_SP+103]-keys.data[KEY_SP+101])*20;
		rforce->data[0]-=mouse[0]; mouse[0]=0;
		rforce->data[1]-=mouse[1]; mouse[1]=0;
		rforce->data[2]+=(keys.data[KEY_SP+108]-keys.data[KEY_SP+106])*10;
	}
};
void avatar::draw(bool human) {
	if (!human) {glColor3f(1,1,1); glutSolidSphere(.1,10,10); }
};
//
class particle : public animated {
	public:
		particle(void) : animated() {index=ANI_PARTICLE;}
		particle(float *p) : animated() {index=ANI_PARTICLE; memcpy(&mat->data[12],p,12);};
		void control(bool human) {};
		void draw(bool human) {};
};
void drawShape(matrix<float> &shp);
class myShape : public animated {
	public:
		myShape(matrix<float> shp) : animated() {index=ANI_SHAPE; shape=new matrix<float>(); *shape=shp;};
		void control(bool human) {};
		void draw(bool human) {drawShape(*shape);};
	matrix<float> *shape;
};

//--------------------------------------------------------------------------
class bubble : public animated {
	public:
		bubble(void) : animated() {index=ANI_BUBBLE; col[0]=.9; col[1]=.9; col[2]=.9; col[3]=1; res=4; };
		void control(bool human) {};
		void draw(bool human);
		float col[4];
		int res; //resolution
};
void bubble::draw(bool human) {
	matrix<float> d=*bound;
	d/=1.;
	d.apply(sqrt);
	glColor4fv(col);
	glScalef(d.data[0],d.data[1],d.data[2]);
	glutSolidSphere(1,res,res);	
};
//--------------------------------------------------------------------------
class triangle : public animated {
	public:
		triangle(void);
		triangle(float *a,unsigned int hnd);
		triangle(float *v0,float *v1,float *v2,unsigned int hnd);
		void control(bool human) {};
		void draw(bool human);
		matrix<float> *ext; //vertices for drawing
		matrix<float> *bar; //baricentric coordinates ("inverse" of ext)
		unsigned int tex; 	//texture handle
		float drw[12];    		//color or texture info
		float ups[2];				//heights
};
triangle::triangle(void) : animated() {
	index=ANI_TRIANGLE;
	ext=new matrix<float>(4,3,""); //each col=[dx dy  0 1]^T
	bar=new matrix<float>(3,4,""); //each row=[nx ny .3 0]^T
	medium=ANI_ONGROUND;
	tex=0;
};
triangle::triangle(float *a,unsigned int hnd) : animated() {
	index=ANI_TRIANGLE;
	ext=new matrix<float>(4,3,""); //each col=[dx dy  0 1]^T
	bar=new matrix<float>(3,4,""); //each row=[nx ny .3 0]^T	
	int cnt=0;
	memcpy(mat->data	,&a[cnt],16*4); cnt+=16; //orthonormal system
	memcpy(ext->data	,&a[cnt],12*4); cnt+=12; //makes drawing
	memcpy(bar->data	,&a[cnt],12*4); cnt+=12; //baricentric check
  tex=            hnd+a[cnt];				cnt+=1;  //offset plus texture id
	memcpy(drw				,&a[cnt],12*4); cnt+=12; //color
	memcpy(ups				,&a[cnt], 2*4); cnt+=2;  //height (does this have effect yet)
	setMassAndG(a[cnt],1);						cnt+=1;  //mass
	medium=ANI_ONGROUND;
};
triangle::triangle(float *v0,float *v1,float *v2,unsigned int hnd) : animated() {
	int c1;
	index=ANI_TRIANGLE;
	matrix<float> t0,t1,t2;
	matrix<float> w0(4,1,""); memcpy(w0.data,v0,12);
	matrix<float> w1(4,1,""); memcpy(w1.data,v1,12);
	matrix<float> w2(4,1,""); memcpy(w2.data,v2,12);
	t0=(w0+w1+w2)*.33333333333;
	w0-=t0; w1-=t0; w2-=t0;
	memcpy(&mat->data[12],t0.data,12); mat->data[15]=1;
	t0=w0; 						t0.normalize(); memcpy( mat->data    ,t0.data,12); //lever
	t1=w1-t0*(w1|t0); t1.normalize(); memcpy(&mat->data[ 4],t1.data,12);	
	t2=t0&t1;													memcpy(&mat->data[ 8],t2.data,12);
	t0=mat->glInverse();
	ext=new matrix<float>(4,3,"ones"); //each col=[dx dy  0 1]'
	memcpy( ext->data   ,(t0*w0).data,8); ext->data[1]=0;
	memcpy(&ext->data[4],(t0*w1).data,8);
	memcpy(&ext->data[8],(t0*w2).data,8);	
	oomass=0;
	t0=matrix<float>(3,3,"");
	memcpy( t0.data   , ext->data   ,12);
	memcpy(&t0.data[3],&ext->data[4],12);
	memcpy(&t0.data[6],&ext->data[8],12);
	for (c1=2;c1<12;c1+=4) ext->data[c1]=0;
	bar=new matrix<float>(3,4,"");
	memcpy(bar->data,t0.solve(matrix<float>(3,3,"eye")).data,36);	
	tex=0;
	//drw and ups are missing
	setMassAndG(0,0);
	cout << *mat << *ext << *bar;
}
void triangle::draw(bool human) {
	glColor3f(1,1,0);
	glutSolidSphere(.03,4,4);
	if (tex) {
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D,tex);
		glBegin(GL_TRIANGLES);
			glTexCoord2fv( drw   ); glVertex2fv( ext->data   );
			glTexCoord2fv(&drw[4]); glVertex2fv(&ext->data[4]);
			glTexCoord2fv(&drw[8]); glVertex2fv(&ext->data[8]);
		glEnd();
		glDisable(GL_TEXTURE_2D);
	} else {
		glBegin(GL_TRIANGLES);
			glColor4fv( drw   ); glVertex2fv( ext->data   );
			glColor4fv(&drw[4]); glVertex2fv(&ext->data[4]);
			glColor4fv(&drw[8]); glVertex2fv(&ext->data[8]);
		glEnd();
	}
};
//--------------------------------------------------------------------------
class transient : public animated {
	public:
		transient(void);
		void control(bool human);
		void draw(bool human);		
		matrix<float> *susp;
		unsigned int list;				//texture handle
};

transient::transient(void) : animated() {
	susp=new matrix<float>("data\\dinghy0.tsp");
	*rfric*=6; *ofric*=6;
	ofric->data[0]*=4;
	ofric->data[2]*=4;
}

void transient::control(bool human) {
	int c1;
	animated* ani=(animated*)carrier;
	matrix<float> phas=*((animated*)ani->carrier)->mat**ani->mat;	//only for phantom :-(
	matrix<float> sdif=*susp-mat->glInverse()*phas**susp;
	matrix<float> ones(susp->size[1],1,"ones");
	*oforce-=sdif*ones*15;
	oforce->data[0]*=4;
	oforce->data[2]*=4;
	matrix<float> levr(4,1,"");
	matrix<float> away(4,1,"");
	for (c1=0;c1<susp->size[1];c1++) {
		memcpy(levr.data,&susp->data[c1*4],12);
		memcpy(away.data,&sdif.data [c1*4],12);
		*rforce-=levr&away*10;		
	};
};

void transient::draw(bool human) {glCallList(list);};

//--------------------------------------------------------------------------
//HELPER FUNCTIONS FOR DISPLAY PANEL
//--------------------------------------------------------------------------
void scale3d(float fval,float fmin,float fmax) {
	float p,w=.1,h=.01,t=.01;
	p=2*w*(fval-fmin)/(fmax-fmin);
	glLineWidth(4);	glColor3f(.9,.1,.9);
	glBegin(GL_LINES);
		glVertex3f(-w+p, h,0);
		glVertex3f(-w+p,-h,0);
	glEnd();
	glLineWidth(2); glColor3f(.3,.3,.3);
	glBegin(GL_LINE_STRIP);
		glVertex3f(-w-t, h,0);
		glVertex3f(+w+t, h,0);
		glVertex3f(+w+t,-h,0);
		glVertex3f(-w-t,-h,0);
		glVertex3f(-w-t, h,0);
	glEnd();
};
void circle3d(float r,float deg1,float deg2) {
	float c1,d1,d2,dd;
	glLineWidth(2); glColor3f(.3,.3,.3);	
	d1=deg1*pi*0.005555;
	d2=deg2*pi*0.005555;	
	dd=(d2-d1)*.01;
	glBegin(GL_LINE_STRIP);	
	for (c1=d1;c1<d2;c1+=dd) glVertex3f(r*cos((double)c1),r*sin((double)c1),0);
	glEnd();
};
void meter3d(float fval,float fmin,float fmax) {
	double p,r=.1;
	p=pi*1.25-(fval-fmin)/(fmax-fmin)*pi*1.5;
	glLineWidth(4);	glColor3f(.9,.1,.9);
	glBegin(GL_LINES);
		glVertex3f(0,0,0);
		glVertex3f(r*cos(p),r*sin(p),0);
	glEnd();
	circle3d(r,-45,225);
};



//--------------------------------------------------------------------------
//OLD CODE
//--------------------------------------------------------------------------
//iterate
		/*glPushMatrix(); glLoadIdentity();
			glTranslatef(wot->data[3],wot->data[4],wot->data[5]); //mot in world   coordinate system
			glMultMatrixf(mat->data);			
			glTranslatef(mot->data[3],mot->data[4],mot->data[5]); //mot in objects coordinate system
			for (c1=0;c1<3;c1++) 
				glRotatef(rot->data[3+c1],(c1==0),(c1==1),(c1==2));
			glGetFloatv(GL_MODELVIEW_MATRIX,mat->data);	glPopMatrix();*/
			
//--------------------------------------------------------------------------
/*class camera : public animated {public: //later merge CAMERA with AVATAR
	camera(void);	
	void humanize(void);
	void live(void);
};
camera::camera(void) : animated() {index=ANI_CAMERA;};
void camera::humanize(void) {};
void camera::live(void) {
	glPushMatrix();
		glMultMatrixf(mat->data);
		glColor3f(1,1,1);
		glutSolidSphere(.01,10,10);		
	glPopMatrix();
};*/
//--------------------------------------------------------------------------
/*class rocket : public animated {public:
	rocket(void);	
	void humanize(void);
	void live(void);
};
rocket::rocket(void) : animated() {
	index=ANI_ROCKET;
};
void rocket::humanize(void) {};
void rocket::live(void) {
	int c1;
	float vp[6];
	target(0,vp);
	integrate(1,2);	*mot*=ani_integral;
	integrate(2,4); *rot*=ani_integral;
	motion(true); //motion
	glPushMatrix();
		glMultMatrixf(mat->data);
		glutSolidSphere(.1,10,10);
		//unsigned int *lay=(unsigned int*)carrier;
		//glCallList(*lay);
	glPopMatrix();
};*/
