#include "fmod/fmod.h"
#include "fmod/fmod_errors.h"

#define CHANNELS 1024
#define MAXDIST 1000000000.0f

array<int> channels(1,new int(CHANNELS),0);

class fmSound {
	public:
		fmSound(void);
		int request(void); //returns channels
		void free(int c) {channels.data[c]=1; };
		void flush(FSOUND_SAMPLE *smp,int vol,bool sur,float *pos,float *vel);
		void music(bool on) {if (!on) vol=0; FMUSIC_SetMasterVolume(mod,vol);};
		update(void);
		FMUSIC_MODULE *mod; //music		
		char **list;
		matrix<int> *play;
		int vol,check;		
};

fmSound::fmSound(void) {
	FSOUND_Init(44000,CHANNELS,0);
	channels.data[0]=1; //occupied by default
	mod=NULL;
	int plays=9;
	play=new matrix<int>(plays,1,"fill"); //playlist
	//play->size[2]=1;
	list=new char*[plays];
		list[0]="data/bwv0548_f.mid";
		list[1]="data/bwv0566.mid";
		list[2]="data/bwv0593_1.mid";
		list[3]="data/bwv0596_4.mid";
		list[4]="data/bwv0992_6.mid";
		list[5]="data/bwv1014_4.mid";
		list[6]="data/bwv1016_4.mid";
		list[7]="data/bwv1017_3.mid";
		list[8]="data/bwv1049_3.mid";
	FSOUND_SetMixer(FSOUND_MIXER_QUALITY_MMXP6);
	FSOUND_3D_SetDistanceFactor(1);
	FSOUND_3D_SetDopplerFactor(1);
	FSOUND_3D_SetRolloffFactor(.8);			
	vol=150;
	check=0;
	//int c;for (int c1=0;c1<20;c1++) {c=request(); printf("%i ",c);	channels.data[c]=0; }
};

int fmSound::request(void) {
	while (channels.token()); //might be dangerous :-)
	int c=channels.size[1]-1;
	channels.data[c]=1; //occupy channels
	return c;
};

void fmSound::flush(FSOUND_SAMPLE *smp,int vol,bool sur,float *pos,float *vel) {
	int c=request();
	FSOUND_PlaySound(c,smp);
	FSOUND_SetVolume(c,vol);
	FSOUND_SetSurround(c,sur);
	FSOUND_3D_SetAttributes(c,pos,vel);
	free(c);
};

fmSound::update(void) {
	if (check--<0) {check=100; //proceed w/ next music peace in playlist if neccessary
		if (mod==NULL||FMUSIC_IsFinished(mod)) {
			FMUSIC_FreeSong(mod);
			mod=FMUSIC_LoadSong(list[play->token()]);
			FMUSIC_PlaySong(mod);
			FMUSIC_SetMasterVolume(mod,vol);
			FMUSIC_SetReverb(true);
			FMUSIC_SetLooping(mod,false);			
		}
	}
	if (keys.data[115]) {//user information			
		char glt[80];	check-=10;
		sprintf(glt,"Sound@%4.1f vol[%3i]",FSOUND_GetCPUUsage(),FSOUND_GetSFXMasterVolume());
		linked_label.append(new glLabelText(0,frame_h-11,glt,fnt0));
		sprintf(glt,"channels: %3i %i mute:%i",FSOUND_GetChannelsPlaying(),channels.size[1],FSOUND_GetMute(0));
		linked_label.append(new glLabelText(0,frame_h-22,glt,fnt0));
		sprintf(glt,"Music@%4i vol[%3i]",play->token(0)-1,vol);
		linked_label.append(new glLabelText(0,frame_h-33,glt,fnt0));
		if (keys.data[109+KEY_DOWN])
			if (FSOUND_GetMute(0)) 	FSOUND_SetMute(FSOUND_ALL,false);
				else									FSOUND_SetMute(FSOUND_ALL,true);
		if (keys.data[110+KEY_DOWN]) mod=NULL;			
		vol=MIN(MAX(0,vol-keys.data[45]+keys.data[61]),256)*(1-keys.data[48]);
		FMUSIC_SetMasterVolume(mod,vol);
	}
	FSOUND_Update();
}