//sse abreviates: Scotts Subdivision Engine
#include "scott\AdaptiveMesh.h"
#include "scott\TetrahedralSubdivision.h"
#include "scott\TetrahedralSubdivision.cpp"
#include "scott\AdaptiveMesh.cpp"
#include "scott\ArrayMesh.cpp"
#include "scott\Mesh.cpp"
#include "..\hash.h"

matrix<float>      **base; //subdivision standard
matrix<int>        **bvfn;
matrix<int>        **bfv;
matrix<float>      **grid;
matrix<float>      **ginv;
array<float>				*marr,*mact; //10xmodel  
matrix<float>				*mbar; //cntxmodel
array<bool>					*mbol; //
sparse<float> 			*mbrs; //sparse mbol
array<float>				*mvol; //all cntrl faces
array<unsigned int> *mind; //3xtriangles
matrix<float> 			*mext; //4x2 extention
array<float>				*vind; //vind (holds integer values)
matrix<float>				*vpos; //4xvertices
array<int>					*vfnd; //vpos close to model
Mesh *cntrl,*subdiv,*tempor; //sse
matrix<int> *sedg; //holds extra list for boundary edges
array<int> *cselv,*cself,*fselv; //select vertices
array<float> *csys; 			//coordinate systems
array<ani_system*> *asys;  //coordinate systems
//array<int> *cdom;   			//coordinate systems DOF (see below for bitwise occupation)
matrix<int> *mtEd;
array<float> *diEd;
array<animated*> *anig;		//cntrl vertices are animated ?

array<unsigned int> *prime;
hash<int,int> *vhsh;
hash<matrix<int>,float> *phsh;
linked<matrix<float> > *ltst;
bool draw_Vert=true;

#define SUB_VERT 1
#define SUB_EDGE 2
#define SUB_TRIA 3
#define SUB_QUAD 4
#define SUB_TETR 5
#define SUB_OCTA 6
#define SUB_PRIS 7
#define SUB_CUBE 8
#define SUB_NDIMS  1+2
#define SUB_TOGGLE 4
#define SUB_SELECT 8
#define SUB_COLOR  16
#define SUB_COLORP 31
#define SUB_CARRIER 512

#define OPT_PROT 1		//protected
#define OPT_XMIR 2		//xmirror
#define OPT_YZPR 4		//yzproject

#define HASHNUMEL 200

void init(void) {
	array_print=false;
	base=new matrix<float>*[9];
	bvfn=new matrix<int>*[9];
	bfv=new matrix<int>*[9];
	grid=new matrix<float>*[9];
	ginv=new matrix<float>*[9];
	base[SUB_VERT]=new matrix<float>("data\\base1.v"); base[SUB_VERT]->size[2]=0; //dimension
	base[SUB_EDGE]=new matrix<float>("data\\base2.v"); base[SUB_EDGE]->size[2]=1;
	base[SUB_TRIA]=new matrix<float>("data\\base3.v"); base[SUB_TRIA]->size[2]=2;
	base[SUB_QUAD]=new matrix<float>("data\\base4.v"); base[SUB_QUAD]->size[2]=2;
	base[SUB_TETR]=new matrix<float>("data\\base5.v"); base[SUB_TETR]->size[2]=3;
	base[SUB_OCTA]=new matrix<float>("data\\base6.v"); base[SUB_OCTA]->size[2]=3;
	base[SUB_PRIS]=new matrix<float>("data\\base7.v"); base[SUB_PRIS]->size[2]=3+4; //toggle
	base[SUB_CUBE]=new matrix<float>("data\\base8.v"); base[SUB_CUBE]->size[2]=3;	
	bvfn[SUB_TETR]=new matrix<int>	("data\\base5.vfn");
	bvfn[SUB_OCTA]=new matrix<int>	("data\\base6.vfn");
	 bfv[SUB_TETR]=new matrix<int>	("data\\base5.fv");
	 bfv[SUB_OCTA]=new matrix<int>	("data\\base6.fv");	
	grid[SUB_TETR]=new matrix<float>("data\\base5.grd");	
	ginv[SUB_TETR]=new matrix<float>("data\\base5.gin");
	array_print=true;
	vind=NULL; vpos=NULL;	vfnd=NULL; vhsh=NULL; phsh=NULL;
	cntrl=NULL; subdiv=NULL;
	sedg=NULL;
	prime=new array<unsigned int>("data\\prime5.tab");	
	ltst=NULL;	
	mtEd=NULL;
  diEd=NULL;
  //exit(1);
};

unsigned int vhash(int k) {
	return prime->data[k];
};

unsigned int hashbf(matrix<int> k) {
	unsigned int n=1;
	for (int c1=0;c1<k.numel;c1++) n*=prime->data[k.data[c1]];
	n%=HASHNUMEL;
	return n;
};

bool hash2border(matrix<int> tri) {
	Face f(3);
	memcpy(f.data,tri[0],12);
	subdiv->addFace(&f);
	return true;
}


void meshInfo(int a,int b,Mesh* msh) {	
	char glt[80];
	sprintf(glt,"V:%5i F:%5i",msh->getNumVertices(),msh->getNumFaces());
	linked_label.append(new glLabelText(a,b,glt,fnt1));	
}

int shapeid(matrix<float> &shape) {
	int n=shape.size[1];
	if (n==4&&(shape.size[2]&SUB_NDIMS)==3) return SUB_TETR;
	if (n==6&&(shape.size[2]&SUB_TOGGLE)  ) return SUB_PRIS;
	return n;
};

matrix<float> normal(matrix<float> &shape,int f) {//normal of face f of shape		
	int id=shapeid(shape),ofs=f*bvfn[id]->size[0],shl=shape.size[0];
	matrix<float> v0(3,1,""); memcpy(v0.data,&shape.data[bvfn[id]->data[ofs+0]*shl],12);
	matrix<float> v1(3,1,""); memcpy(v1.data,&shape.data[bvfn[id]->data[ofs+1]*shl],12);
	matrix<float> v2(3,1,""); memcpy(v2.data,&shape.data[bvfn[id]->data[ofs+2]*shl],12);
	v0-=v2;
	v1-=v2;
	v0&=v1;
	v0.normalize();
	return v0;
};

bool bary(matrix<float> &shape,float *p,matrix<float> &w) {
	int c1,c2,n=shape.size[1],id=shapeid(shape),f=bvfn[id]->size[1];	
	int env=bfv[id]->size[0];	//# faces around vertex	
	float n1,nj,nk,sum=0,vol;
	w=matrix<float>(n,1,"");
	matrix<float> x(3,1,""),v(3,1,"");
	memcpy(x[0],p,12);
	matrix<float> *N=new matrix<float>[f]; //array of matrices
	int ind[5];
	for (c1=0;c1<f;c1++) N[c1]=normal(shape,c1);
	for (c1=0;c1<n;c1++) {
		memcpy(v.data,&shape.data[c1*shape.size[0]],12);
		memcpy(ind,&bfv[id]->data[env*c1],4*env);
		n1=(v-x)|N[ind[0]];
		for (c2=1;c2<env-1;c2++) {
			vol=fabs(N[ind[0]]|(N[ind[c2]]&N[ind[c2+1]]));
			nj=(v-x)|N[ind[c2]];
			nk=(v-x)|N[ind[c2+1]];
			w.data[c1]+=vol/(n1*nj*nk);			
		}
		if (w.data[c1]<0) return false;
		sum+=w.data[c1];
	}
	w*=(1/sum);
	if ((w>0).all()) return true; else return false;
};

template <class type> void minmax(matrix<type> &body,float p) {
	int c1,c2,s0=body.size[0];
	matrix<type> ext(s0,2,"");
	memcpy(ext[ 0],body[0],s0*sizeof(type));
	memcpy(ext[s0],body[0],s0*sizeof(type));
	for (c1=0;c1<s0;c1++)
	for (c2=0;c2<body.size[1];c2++) {
		ext.data[c1   ]=MIN(ext.data[c1   ],body.data[c2*s0+c1]);
		ext.data[c1+s0]=MAX(ext.data[c1+s0],body.data[c2*s0+c1]);	}	
	for (c1=0;c1<s0;c1++) {
		ext.data[c1   ]-=p;
		ext.data[c1+s0]+=p;	}	
	for (c1=0;c1<2*s0;c1++) mext->data[c1]=ROUND(ext.data[c1]);
	//for (c1=0;c1<2*s0;c1++) mext->data[c1]=ext.data[c1];
};

void drawExt(matrix<float> &ext) {
	glPointSize(10);
	glNormal3f(0,1,0);
	glColor3f(1,1,1);
	glBegin(GL_POINTS);
		glVertex3fv(ext[0]);
		glVertex3fv(ext[4]);
	glEnd();
};

matrix<float> face2shape(Mesh* msh,int ind) {
	int c1;
	matrix<float> shape;
	Face f=*msh->getFace(ind);
	switch (f.length) {
		case 3:	shape=*base[SUB_TRIA]; break;
		case 4:	shape=*base[SUB_TETR]; break;
		case 6:	shape=*base[SUB_OCTA]; break;
	}
	for (c1=0;c1<f.length;c1++) {
		if (f.data[c1]>=msh->getNumVertices()) 
			printf("F2S Error: %i %i \n",f.data[c1],msh->getNumVertices());
		memcpy(&shape.data[c1*4],msh->getVertex(f.data[c1])->data,12);
	}
	if (msh==cntrl) shape.size[2]|=SUB_COLOR*cself->data[ind];
	//printf("-%i ",shape.size[2]);	
	return shape;
}

float shapeVol(matrix<float> shp) {
	int c1,c2;
	float vol=0;
	switch (shapeid(shp)) {
		case SUB_TETR:
			for (c1=0;c1<3;c1++)
			for (c2=0;c2<3;c2++)
				shp.data[c1*4+c2]=shp.data[c1*4+c2]-shp.data[12+c2];
			vol=-0.166666666666*shp.glDet();			
			break;
	}
	if (vol<0) printf("%5.2f ",vol);
	return vol;
}

matrix<float> shapeCenter(matrix<float>& shp) {
	int sln=shp.size[1];
	matrix<float> men(sln,1,"ones");
	men*=1/(float)sln;
	return shp*men;
}

void MeshExplode(Mesh* msh) {
	int c1;
	for (c1=0;c1<msh->getNumFaces();c1++) {
		if (msh->getFace(c1)->length>3) {
			myShape* mS=new myShape(face2shape(msh,c1));
			*mS->tforce=shapeCenter(face2shape(msh,c1))*30;
			linked_ani.append(mS);
		}
	}
}

//void shape2face(Mesh *msh) {};

bool findClosest(Mesh* msh,float *p,float d,int &ind,bool drw) {
	//returns closest vertex v if p closest to v and distance < d
	int c1;
	matrix<float> x(3,1,""),v(3,1,"");	
	memcpy(x[0],p,12);
	float vmd=100,vcd;
	int vmi=0;
	for (c1=0;c1<msh->getNumVertices();c1++) {
		memcpy(v[0],msh->getVertex(c1)->data,12);
		vcd=(x-v).norm(2);
		if (vcd<vmd) {vmd=vcd; vmi=c1;}
	}	
	if (vmd<d) {
		ind=vmi;
		if (drw) {
			glLineWidth(1);
			if (shot_mode) glColor3f(0,0,0); else glColor3f(1,1,1);
			glBegin(GL_LINES);
				glVertex3fv(msh->getVertex(ind)->data);	
				glVertex3fv(p);
			glEnd();
			matrix<float> x0(4,1,""); memcpy(x0[0],msh->getVertex(ind)->data,12);
			matrix<float> x1(4,1,""); memcpy(x1[0],p,12);
			matrix<float> force=((animated*)P->carrier)->mat->glInverse()*(x0-x1);
			P->glForceAdd+=gstVector(force.data[0],force.data[1],force.data[2])*1;
		}
		return true;
	} else {
		ind=-1;
		return false;
	}
};

void addShape(Mesh *msh,matrix<float> &selS,float d) {
	int c1,also;
	Face f(selS.size[1]);
	Vertex v(4);
	for (c1=0;c1<selS.size[1];c1++) {
		if (findClosest(msh,selS[c1*4],.2,also,false)) f.data[c1]=also;
		else {
			memcpy(v.data,selS[c1*4],12);					
			f.data[c1]=msh->addVertex(&v);
		}
	}
	if (msh==cntrl) cself->data[cntrl->getNumFaces()]=currFlag;
	msh->addFace(&f);	
};

void addBoundary(bool add2Mesh) {
	int c1,c2,c3;
	hash<matrix<int>,matrix<int> > hashb(HASHNUMEL,hashbf);
	int sid;	
	Face fb;
	matrix<int> tri(3,1,""),tr2(3,1,"");
	for (c1=0;c1<subdiv->getNumFaces();c1++) {
		fb=*subdiv->getFace(c1);
		sid=0;
		switch (fb.length) {
			case 4: sid=SUB_TETR; break;
			case 6: sid=SUB_OCTA; break; }
		if (sid)
			for (c2=0;c2<bvfn[sid]->size[1];c2++) {
				for (c3=0;c3<3;c3++) tri.data[c3]=fb.data[bvfn[sid]->data[3*c2+c3]];
				memcpy(tr2[0],tri[0],12);				
				tri.sort();
				if (!hashb.remove(tri)) hashb.store(tri,tr2);
			}
	}
	if (add2Mesh) hashb.apply(hash2border); //adds triangles to the boundary for further subdivision
	else { //this is sad: here we extract edges of boundary for drawing
	hash<matrix<int>,void*> hashl(HASHNUMEL,hashbf);
	bucket<matrix<int>,matrix<int> > b;
	matrix<int> a2(2,1,"");
	for (c1=0;c1<hashb.table->numel;c1++)
		while (hashb.table->data[c1]->token(b))		
			for (c2=0;c2<3;c2++) {
				a2.data[0]=b.key.data[c2];
				a2.data[1]=b.key.data[(c2+1)%3];
				a2.sort();
				hashl.store(a2,NULL);
			}
	if (sedg) delete sedg;
	sedg=new matrix<int>(2,hashl.numel,"");	
	c2=0;
	bucket<matrix<int>,void*> c;
	for (c1=0;c1<hashl.table->numel;c1++)
		while (hashl.table->data[c1]->token(c)) {
			sedg->data[c2*2+0]=c.key.data[0];
			sedg->data[c2*2+1]=c.key.data[1];
			c2++;
		}
	}
}

void addMirror(int no1,int no2) {
	int c1;
	for (c1=0;c1<xmirror->size[1];c1++) //search for free spot and manifest		
		if (xmirror->data[c1*2  ]<0) {
			xmirror->data[c1*2  ]=no1;
			xmirror->data[c1*2+1]=no2;			
			break;
		}
}
void removeMirror(int whch) {
	int c1;
	for (c1=0;c1<xmirror->size[1];c1++) //search for free spot and manifest
		if (xmirror->data[c1*2  ]==whch||xmirror->data[c1*2+1]==whch) {
			xmirror->data[c1*2  ]=-1;
			xmirror->data[c1*2+1]=-1;
		}
}
void drawMirrorAndUpdate(void) {
	int c1;
	for (c1=0;c1<cntrl->getNumVertices();c1++)		
		if (cselv->data[c1]&OPT_XMIR) cselv->data[c1]^=OPT_XMIR;				
	glColor3fv(&colOpt->data[4]);
	glLineWidth(2); glBegin(GL_LINES);	
	for (c1=0;c1<xmirror->size[1];c1++) //search for free spot and manifest
		if (xmirror->data[c1*2]>=0) {
			cselv->data[xmirror->data[c1*2  ]]|=OPT_XMIR;
			cselv->data[xmirror->data[c1*2+1]]|=OPT_XMIR;
			if (xmirror->data[c1*2  ]==currCarrier) {
				memcpy(cntrl->getVertex(xmirror->data[c1*2+1])->data,cntrl->getVertex(xmirror->data[c1*2  ])->data,12);
				cntrl->getVertex(xmirror->data[c1*2+1])->data[0]*=-1; }
			if (xmirror->data[c1*2+1]==currCarrier) {
				memcpy(cntrl->getVertex(xmirror->data[c1*2  ])->data,cntrl->getVertex(xmirror->data[c1*2+1])->data,12);			
				cntrl->getVertex(xmirror->data[c1*2  ])->data[0]*=-1;	}
			glVertex3fv(cntrl->getVertex(xmirror->data[c1*2  ])->data);
			glVertex3fv(cntrl->getVertex(xmirror->data[c1*2+1])->data);			
		}
	glEnd();
}

void addMirrorModel(void) {//this copies the entire model!!!
	int c1;
	int nV=cntrl->getNumVertices();
	int nF=cntrl->getNumFaces();
	Vertex v;
	for (c1=0;c1<nV;c1++) {
		v=*cntrl->getVertex(c1);
		v.data[0]*=-1;
		cntrl->addVertex(&v);
	}	
	int fl;
	matrix<int> fof(8,1,"");
	for (c1=0;c1<nF;c1++) {
		fl=cntrl->getFace(c1)->length;
		memcpy(fof[0],cntrl->getFace(c1)->data,4*fl);
		fof+=nV;
		Face f(fl);
		memcpy(f.data,fof[0],4*fl);
		cntrl->addFace(&f);
	}
	//exit(0);
}

void twoConnect(int vstay,int vbeco) {
	int c1,c2;
	for (c1=0;c1<cntrl->getNumFaces();c1++)
		for (c2=0;c2<cntrl->getFace(c1)->length;c2++) 
			if (cntrl->getFace(c1)->data[c2]==vbeco) cntrl->getFace(c1)->data[c2]=vstay;
	cntrl->getVertex(vbeco)->data[0]=1000;
	for (c1=0;c1<xmirror->size[1];c1++)
		if (xmirror->data[c1*2]==vbeco||xmirror->data[c1*2+1]==vbeco) {
			xmirror->data[c1*2  ]=-1;
			xmirror->data[c1*2+1]=-1;
		};
};

void orientFace(Mesh* msh,int ind) {
	int c1,cnt=20;
	//int n=msh->getVertex(0)->length;
	int f=msh->getFace(ind)->length;
	matrix<float> m(3,1,"");
	matrix<float> v(3,1,"");
	for (c1=0;c1<f;c1++) {
		memcpy(v.data,msh->getVertex(msh->getFace(ind)->data[c1])->data,12);
		m+=v;
	}
	m*=(1/(float)f);	
	matrix<float> w,shp=face2shape(msh,ind);
	int r1,r2;
	while (!bary(shp,m.data,w)&&cnt-->0)	{
		r1=f*rndu->token();
		r2=f*rndu->token();
		c1=msh->getFace(ind)->data[r1];
		msh->getFace(ind)->data[r1]=msh->getFace(ind)->data[r2];
		msh->getFace(ind)->data[r2]=c1;
		shp=face2shape(msh,ind);
	}
}

int thCnt;
bool thEdgeApply(matrix<int> &par,int voi) {
	memcpy(&mtEd->data[(thCnt++)*2],par.data,8);	
	return true;
}

void saveEdges(void) {
	if (mtEd) delete mtEd; mtEd=NULL;
	if (diEd) delete diEd; diEd=NULL;
	int c1,c2,c3,cnt=0,nV;
	nV=cntrl->getNumVertices();	
	hash<matrix<int>,int> thEd(HASHNUMEL,hashbf);
	matrix<int> par(2,1,"");
	float dist;
	for (c1=0;c1<cntrl->getNumFaces();c1++) {		
		if (cntrl->getFace(c1)->length==4)
			for (c2=0;c2<3;c2++)
				for (c3=c2+1;c3<4;c3++) {
					par.data[0]=cntrl->getFace(c1)->data[c2];
					par.data[1]=cntrl->getFace(c1)->data[c3];
					par.sort();
					thEd.store(par,0);
				}
	}
	mtEd=new matrix<int>(2,thEd.numel,"");
	thCnt=0;
	thEd.apply(thEdgeApply);
	mtEd->store((*locat+".edg").str);
	diEd=new array<float>(1,&mtEd->size[1],0);	
	matrix<float> v0(3,1,""),v1(3,1,"");
	for (c1=0;c1<mtEd->size[1];c1++) {
		memcpy(v0.data,cntrl->getVertex(mtEd->data[2*c1  ])->data,12);
		memcpy(v1.data,cntrl->getVertex(mtEd->data[2*c1+1])->data,12);
		diEd->data[c1]=(v0-v1).norm(2);
	}
	//diEd.store((*locat+".w.dst").str); //distance should be computed upon initialisation!!! (otherwise redundant)
	
};


void drawShape(matrix<float> &shape) {
	glNormal3f(0,1,0);
	int n=shape.size[1];//number of vertices
	float cole[4],colf[4];
	//printf("#%i",shape.size[2]);
	if (shot_mode)
		if (shape.size[2]&SUB_SELECT) {
			glLineWidth(3);			
			cole[0]=0; colf[0]= 1;// .8; 
			cole[1]=0; colf[1]= 0;// .8; 
			cole[2]=0; colf[2]= 0;// .8; 
			cole[3]=1; colf[3]= 1; 
		} else {
			glLineWidth(1);
			cole[0]= .8; colf[0]= 0; //memcpy(colf,&selOpt->data[4*(shape.size[2]/16)],16);
			cole[1]= .8; colf[1]= 0;
			cole[2]= .8; colf[2]= 0;
			cole[3]= .2; colf[3]=.05;
			//memcpy(cole,&selOpt->data[4*(shape.size[2]/16)],16);
		}
	else
		if (shape.size[2]&SUB_SELECT) {
			glLineWidth(3);
			memcpy(colf,&selOpt->data[4*(shape.size[2]/SUB_COLOR&SUB_COLORP)],16);
			cole[0]= .8;
			cole[1]= .8;
			cole[2]= .8;
			cole[3]=1  ;
		} else {
			glLineWidth(1);
			cole[0]= .9; memcpy(colf,&selOpt->data[4*(shape.size[2]/SUB_COLOR&SUB_COLORP)],16);
			cole[1]= .9;
			cole[2]= .9;
			cole[3]= .6;
			//memcpy(cole,&selOpt->data[4*(shape.size[2]/16)],16);
		}
		
	//if (keys.data[' ']) colf[3]=1;
	//printf("%i %i\n",n,shape.size[2]&SUB_NDIMS);
	switch (shape.size[2]&SUB_NDIMS) {
	case 0:		
		glPointSize(3);
		glBegin(GL_POINTS);	glVertex3fv(shape.data); glEnd(); 
		break;
	case 1:
		glBegin(GL_LINES);
			glVertex3fv( shape.data   );
			glVertex3fv(&shape.data[4]);
		glEnd();
		break;
	case 2:
		if (n==3) {						
			//glBegin(GL_TRIANGLES); //here the surface (or boundary of the volumetric mesh)
			//	glVertex3fv( shape.data   );
			//	glVertex3fv(&shape.data[4]);
			//	glVertex3fv(&shape.data[8]);
			//glEnd();
			//glColor4f(0,0,1,1);
			glColor3fv(colf);
			glLineWidth(1);
			glBegin(GL_LINE_LOOP);
				glVertex3fv( shape.data   );
				glVertex3fv(&shape.data[4]);
				glVertex3fv(&shape.data[8]);
			glEnd();
			//glLineWidth(1);
		} else
		if (n==4) {
			glBegin(GL_QUADS);
				glVertex3fv( shape.data    );
				glVertex3fv(&shape.data[ 4]);
				glVertex3fv(&shape.data[ 8]);
				glVertex3fv(&shape.data[12]);
			glEnd();
		}
		break;
	case 3:
		if (n==4) {//tetra
			//cole[0]=.5; cole[1]=.5; cole[2]=.5; cole[3]=1;
			glColor4fv(cole);
			glBegin(GL_LINE_STRIP);
				glVertex3fv( shape.data    );
				glVertex3fv(&shape.data[ 4]);
				glVertex3fv(&shape.data[ 8]);
				glVertex3fv(&shape.data[12]);
				glVertex3fv( shape.data    );
				glVertex3fv(&shape.data[ 8]);
				glVertex3fv(&shape.data[ 4]);					
				glVertex3fv(&shape.data[12]);			
			glEnd();
			glColor4fv(colf);
			glBegin(GL_TRIANGLE_STRIP);
				glVertex3fv( shape.data    );
				glVertex3fv(&shape.data[ 4]);
				glVertex3fv(&shape.data[ 8]);
				glVertex3fv(&shape.data[12]);
				glVertex3fv( shape.data    );
				glVertex3fv(&shape.data[ 4]);
			glEnd();			
		} else
		if (n==6&&!(shape.size[2]&SUB_TOGGLE)) {//octa			
			glColor4fv(cole);
			glBegin(GL_LINE_STRIP);
				glVertex3fv( shape.data    );
				glVertex3fv(&shape.data[ 4]);
				glVertex3fv(&shape.data[ 8]);
				glVertex3fv( shape.data    );
				glVertex3fv(&shape.data[16]);					
				glVertex3fv(&shape.data[12]);
				glVertex3fv(&shape.data[20]);
				glVertex3fv(&shape.data[16]);					
				glVertex3fv(&shape.data[ 8]);
				glVertex3fv(&shape.data[12]);
				glVertex3fv(&shape.data[ 4]);					
				glVertex3fv(&shape.data[20]);
				glVertex3fv( shape.data    );					
			glEnd();
			glColor4fv(colf); 			
			glBegin(GL_TRIANGLE_FAN);
				glVertex3fv( shape.data    );
				glVertex3fv(&shape.data[ 8]);
				glVertex3fv(&shape.data[ 4]);
				glVertex3fv(&shape.data[20]);
				glVertex3fv(&shape.data[16]);
				glVertex3fv(&shape.data[ 8]);
			glEnd();
			glBegin(GL_TRIANGLE_FAN);
				glVertex3fv(&shape.data[12]);
				glVertex3fv(&shape.data[ 8]);
				glVertex3fv(&shape.data[ 4]);
				glVertex3fv(&shape.data[20]);
				glVertex3fv(&shape.data[16]);
				glVertex3fv(&shape.data[ 8]);
			glEnd();
		} else {//prism
		};
		if (n==8) {//cube
		};
		break;
	}	
}

void drawMesh(Mesh *msh) {	
	for (int c1=msh->getNumFaces()-1;c1>=0;c1--) drawShape(face2shape(msh,c1));	
}

void drawVertices(void) {
	int c1,ci;
	float sphsz;
	matrix<float> col(4,1,""),add(4,1,"");
	for (c1=0;c1<cntrl->getNumVertices();c1++) {
		if (cselv->data[c1]&&!shot_mode) {
			col*=0;
			if (cselv->data[c1]&OPT_PROT) {memcpy(add[0],&colOpt->data[ 0],12); col+=add;}
			if (cselv->data[c1]&OPT_XMIR) {memcpy(add[0],&colOpt->data[ 4],12); col+=add;}
			if (cselv->data[c1]&OPT_YZPR) {memcpy(add[0],&colOpt->data[ 8],12); col+=add;}			
			sphsz=.08;
			glColor3fv(col[0]);
		} else {
			sphsz=.03333;
			glColor3f(0,.8,.4);
		}
		glPushMatrix();
			glTranslatef(cntrl->getVertex(c1)->data[0],
									 cntrl->getVertex(c1)->data[1],
									 cntrl->getVertex(c1)->data[2]);			
			glutSolidSphere(sphsz,10,10);			
			if (ci=cselv->data[c1]/SUB_COLOR&SUB_COLORP) {
				glColor3fv(&selOpt->data[4*ci]);
				float hght=.3;
				glRotatef(90,1,0,0);
				glTranslatef(0,0,-hght);
				glutSolidCone(.1,hght,8,3);
			}
		glPopMatrix();
	}
}


int trisort_cnt;
array<unsigned int> *trisort;
matrix<float> *triproj;
array<float> *tridist;
Mesh *trisort_msh;
matrix<float> *mena;

bool constTris(matrix<int> &tri,void* tr2) {
	memcpy(&trisort->data[trisort_cnt*3],tri[0],12);
	matrix<float> tata(4,3,"ones");
	memcpy(tata[0],trisort_msh->getVertex(tri.data[0])->data,12);
	memcpy(tata[4],trisort_msh->getVertex(tri.data[1])->data,12);
	memcpy(tata[8],trisort_msh->getVertex(tri.data[2])->data,12);	
	tata*=*mena;	
	tridist->data[trisort_cnt]=-(*triproj|tata);
	trisort_cnt++;
	return true;
};

void drawMeshSorted(Mesh *msh) {
	int c1,c2,c3;
	for (c1=0;c1<msh->getNumFaces();c1++)
		if (msh->getFace(c1)->length==3) drawShape(face2shape(msh,c1));
	trisort_msh=msh;
	hash<matrix<int>,void*> hashb(HASHNUMEL,hashbf);
	int sid;	
	Face fb;
	matrix<int> tri(3,1,""),tr2(3,1,"");
	for (c1=0;c1<msh->getNumFaces();c1++) {
		fb=*msh->getFace(c1);
		sid=0;
		switch (fb.length) {
			case 4: sid=SUB_TETR; break;
			case 6: sid=SUB_OCTA; break; }
		if (sid)
			for (c2=0;c2<bvfn[sid]->size[1];c2++) {
				for (c3=0;c3<3;c3++) tri.data[c3]=fb.data[bvfn[sid]->data[3*c2+c3]];				
				tri.sort();
				hashb.store(tri,NULL);
			}
	}	
	unsigned char col[4],lev;
	if (shot_mode) lev=10; else lev=200;
	col[0]=lev; col[1]=lev; col[2]=lev; col[3]=30;
	matrix<float> vertsort(4,msh->getNumVertices(),"");
	for (c1=0;c1<msh->getNumVertices();c1++) {
		memcpy(vertsort[c1*4  ],col,4);
		memcpy(vertsort[c1*4+1],msh->getVertex(c1)->data,12);
	}
	trisort_cnt=0;
	int sz[2]; sz[0]=3; sz[1]=hashb.numel;
	trisort=new array<unsigned int>(2,sz,0);
	tridist=new array<float>(1,&sz[1],0);
	matrix<float> w(4,4,"");
	glGetFloatv(GL_MODELVIEW_MATRIX,w.data);
	triproj=new matrix<float>(4,1,"");
	matrix<float> triTemp=project*w;
	triproj->data[0]=triTemp.data[ 3];
	triproj->data[1]=triTemp.data[ 7];
	triproj->data[2]=triTemp.data[11];
	triproj->data[3]=triTemp.data[15];
	mena=new matrix<float>(3,1,"ones");
	*mena*=.3333333333333333333;
	
	hashb.apply(constTris);
	array<int> sind=tridist->sort();
	array<unsigned int> finalt(2,sz,0);
	for (c1=0;c1<sind.numel;c1++)
		memcpy(finalt[c1*3],&trisort->data[sind.data[c1]*3],12);
	
	glInterleavedArrays(GL_C4UB_V3F,0,vertsort[0]);	
	glDrawElements(GL_TRIANGLES,finalt.numel,GL_UNSIGNED_INT,finalt.data);
	delete trisort;
	delete triproj;
	delete tridist;
	delete mena;
}


void renderMesh(Mesh *msh) {
	int c1;
	glColor3f(.97,.53,.3);
	glEnable(GL_LIGHTING);
	glBegin(GL_TRIANGLES);
	matrix<float> v0(3,1,"");
	matrix<float> v1(3,1,"");
	matrix<float> v2(3,1,"");
	matrix<float> nrm(3,1,"");
	for (c1=0;c1<msh->getNumFaces();c1++) 
		if (msh->getFace(c1)->length==3) {
			memcpy(v0[0],msh->getVertex(msh->getFace(c1)->data[0])->data,12);
			memcpy(v1[0],msh->getVertex(msh->getFace(c1)->data[1])->data,12);
			memcpy(v2[0],msh->getVertex(msh->getFace(c1)->data[2])->data,12);
			nrm=(v2-v0)&(v1-v0);
			nrm.normalize();
			glNormal3fv(nrm[0]);
			glVertex3fv(v0[0]);
			glVertex3fv(v1[0]);
			glVertex3fv(v2[0]);
		}
	glEnd();
	glDisable(GL_LIGHTING);
}
bool loadFrame(void) {
	char glt[10];
	sprintf(glt,".%i",currFrame);
	matrix<float> saveV((*locat+glt+".mv3").str);
	if (saveV.data) {
		for (int c1=0;c1<saveV.size[1];c1++)
			memcpy(cntrl->getVertex(c1)->data,saveV[c1*3],12);
		return true;
	}	else return false;
};

void saveFrame(void) {
	char glt[10];
	sprintf(glt,".%i",currFrame);
	matrix<float> saveV(3,cntrl->getNumVertices(),"");
	for (int c1=0;c1<cntrl->getNumVertices();c1++)
		memcpy(saveV[c1*3],cntrl->getVertex(c1)->data,12);
	saveV.store((*locat+glt+".mv3").str);
};

matrix<unsigned int> *saveDi;
array<float> *saveDd;
int global_cnt=0;

bool psta(matrix<int> &ind,float d) {
	saveDi->data[2*global_cnt+0]=ind.data[0];
	saveDi->data[2*global_cnt+1]=ind.data[1];
	saveDd->data[  global_cnt  ]=d;
	global_cnt++;
	return true;
};

void saveWabble(void) {
	int c1;
	array<float> saveM(1,&anig->numel,0);
	for (c1=0;c1<anig->numel;c1++) saveM.data[c1]=anig->data[c1]->oomass;
	saveM.store((*locat+".d.oms").str);
	int n=phsh->howmany();
	saveDi=new matrix<unsigned int>(2,n,"");
	saveDd=new array<float>(1,&n,0);
	global_cnt=0;
	phsh->apply(psta);
	saveDi->store((*locat+".d.ind").str);
	saveDd->store((*locat+".d.ist").str);
	delete saveDi;
	delete saveDd;
	mbar->store((*locat+".d.bar").str);
}

void exportTriangles(Mesh *msh) {
	char glt[10];
	sprintf(glt,"%i",currFrame);
	int nV=msh->getNumVertices();
	int nF=msh->getNumFaces();
	int c1,c2,fl,tri=0,ver=1,cnt=0;
	array<int> bor(1,new int(nV),0); //writes new index at required vertex	
	for (c1=0;c1<nF;c1++) {
		fl=msh->getFace(c1)->length;
		if (fl==3) {
			tri++;
			for (c2=0;c2<3;c2++)
				if (!bor.data[msh->getFace(c1)->data[c2]])
					bor.data[msh->getFace(c1)->data[c2]]=ver++;
		}
	}
	ver-=1;
	cout << "Mesh: #" << nV << " -> export V:" << ver << " T:" << tri << endl;

	int cmt=0,size[2];
	size[0]=6;  size[1]=nV; array<float> saveV(2,size,0);		
	size[0]=10; size[1]=nV; array<float> saveA(2,size,0);
	
	matrix<float> nrm(3,1,"");
	for (c1=0;c1<nV;c1++)
		if (cnt=bor.data[c1]) {//cnt has index number used in T of vertex						
			memcpy(nrm[0]    ,msh->getVertex(c1)->data,12);
			//nrm.normalize();
			cmt=10*(cnt-1);
			saveA.data[cmt+0]=rndu->token();
			saveA.data[cmt+1]=rndu->token();
			saveA.data[cmt+2]=rndu->token();
			saveA.data[cmt+3]=.3; //.3 for collision meshes			
			memcpy(saveA[cmt+7],nrm[0],12);
			cnt-=1;
			cnt*=6;
			saveV.data[cnt++]=rndu->token();
			saveV.data[cnt++]=rndu->token();
			saveV.data[cnt++]=rndu->token();
			memcpy(saveV[cnt],nrm[0],12);
		}
	saveV.store((*locat+glt+".cv").str);
		
	size[0]=3; size[1]=tri; array<unsigned int> saveF(2,size,0);
	cnt=0;
	for (c1=0;c1<nF;c1++) {
		fl=msh->getFace(c1)->length;
		if (fl==3) {
			tri++;
			saveF.data[cnt++]=bor.data[msh->getFace(c1)->data[0]]-1;
			saveF.data[cnt++]=bor.data[msh->getFace(c1)->data[1]]-1;
			saveF.data[cnt++]=bor.data[msh->getFace(c1)->data[2]]-1;
		}
	}
	saveF.store((*locat+glt+".ind").str);
	glAverageNormals(&saveA,&saveF,false);
	saveA.store((*locat+glt+".arr").str);
};

void baryModelQS(void) {//standalone optimized modelV->subdivBary
	int c1,c2,c3,c4,csh,cnt=0,n,id,f,env,ind[5],nV=mact->size[1],nS=0;
	int btic=clock();
	char canBe=0;
	float n1,nj,nk,sum,vol;
	int lb=subdiv->getVertex(0)->length-4; //# of control points	
	Face fa;
	printf("baricentric:");
	if (mbar) delete mbar; //mbar is a [cP x mV]
	mbar=new matrix<float>(lb,nV,"");
	matrix<float> v(3,1,"");
	for (c1=0;c1<subdiv->getNumFaces();c1++)		//cnt number of volume shapes	
		if (subdiv->getFace(c1)->length>3) nS++;
	array<float> mvsy(1,&nV,0);                 //sort model vert
		for (c1=0;c1<nV;c1++) {
			mvsy.data[c1]=mact->data[10*c1+8];      //before: [4*c1+1]
			mbol->data[c1]=false;	}
		array<int> mvsi=mvsy.sort();
	array<float> sinx(1,&nS,0),saxx(1,&nS,0),sinz(1,&nS,0),saxz(1,&nS,0); //bnd box
	array<float> siny(1,&nS,0); //det lower and upper bnd
	array<float> saxy(1,&nS,0);
	cnt=0;
	for (c1=0;c1<subdiv->getNumFaces();c1++)		//cnt number of volume shapes	
		if ((env=subdiv->getFace(c1)->length)>3) {
			saxx.data[cnt]=sinx.data[cnt]=subdiv->getVertex(subdiv->getFace(c1)->data[0])->data[0];
			saxy.data[cnt]=siny.data[cnt]=subdiv->getVertex(subdiv->getFace(c1)->data[0])->data[1];
			saxz.data[cnt]=sinz.data[cnt]=subdiv->getVertex(subdiv->getFace(c1)->data[0])->data[2];
			for (c2=1;c2<env;c2++) {
				n1=subdiv->getVertex(subdiv->getFace(c1)->data[c2])->data[0];
				sinx.data[cnt]=MIN(sinx.data[cnt],n1);
				saxx.data[cnt]=MAX(saxx.data[cnt],n1);
				n1=subdiv->getVertex(subdiv->getFace(c1)->data[c2])->data[1];
				siny.data[cnt]=MIN(siny.data[cnt],n1);
				saxy.data[cnt]=MAX(saxy.data[cnt],n1);
				n1=subdiv->getVertex(subdiv->getFace(c1)->data[c2])->data[2];
				sinz.data[cnt]=MIN(sinz.data[cnt],n1);
				saxz.data[cnt]=MAX(saxz.data[cnt],n1);
			}
			cnt++;
		}
	array<int> sisi=siny.sort();	
	printf(" AABB/QS. S:%i V:%i\n",nS,nV);
	int cs=0,cv=0;
	while (cs<nS&&cv<nV) {		
		if (saxy.data[sisi.data[cs]]<mvsy.data[cv]) cs++;	else 
		if (siny.data[cs]           >mvsy.data[cv]) cv++;	else
		{	
			csh=sisi.data[cs];
			printf("\r %i - %i",cs,cv);
			fa=*subdiv->getFace(csh);
			matrix<float> shape=face2shape(subdiv,csh);
			n=shape.size[1];
			id=shapeid(shape);
			f=bvfn[id]->size[1];  //# of faces
			env=bfv[id]->size[0];	//# faces around each vertex
			matrix<float> col(lb,fa.length,""); //holds bary coords for all verts of fa
			for (c2=0;c2<fa.length;c2++)
				memcpy(col[lb*c2],&subdiv->getVertex(fa.data[c2])->data[4],4*lb);
			matrix<float> w(n,1,"");			
			matrix<float> *N=new matrix<float>[f];       //array of matrices			
			for (c1=0;c1<f;c1++) N[c1]=normal(shape,c1);
			c1=0;
			while (saxy.data[csh]>mvsy.data[cv+c1]) {//for cs check v's						
				c2=mvsi.data[cv+c1]; //hard adress of current model vertex				
				if (!mbol->data[c2])
				if (sinx.data[csh]<mact->data[c2*10+7]&&mact->data[c2*10+7]<saxx.data[csh]) //before: [+0   +0
				if (sinz.data[csh]<mact->data[c2*10+9]&&mact->data[c2*10+9]<saxz.data[csh]) //         +2   +2
				{
					sum=0; canBe=1;
					for (c3=0;c3<n;c3++) {//loop over the shape vertices and assign weight!
						w.data[c3]=0;
						v.data[0]=shape.data[c3*shape.size[0]  ]-mact->data[c2*10+7];
						v.data[1]=shape.data[c3*shape.size[0]+1]-mact->data[c2*10+8];
						v.data[2]=shape.data[c3*shape.size[0]+2]-mact->data[c2*10+9];
						memcpy(ind,&bfv[id]->data[env*c3],4*env); //outside						
						n1=v|N[ind[0]];
						for (c4=1;c4<env-1;c4++) {//for^4 sad and rare occasion
							vol=fabs(N[ind[0]]|N[ind[c4]]&N[ind[c4+1]]); //can be comp outside							
							nj=v|N[ind[c4]];
							nk=v|N[ind[c4+1]];
							w.data[c3]+=vol/(n1*nj*nk);
						}
						if (w.data[c3]<0) {canBe=0; break;}
						sum+=w.data[c3];
					}
					if (canBe) {//comp real barys then
						mbol->data[c2]=true;
						w*=(1/sum);
						memcpy((*mbar)[lb*c2],(col*w).data,4*lb);
					}				
				}
				c1++;
				if (cv+c1>=nV) break;
			} //eo loop over all Vertices	
			delete[] N;
			cs++;
		}
	}
	printf(" %5.2f sec ",(clock()-btic)*.001);
	cnt=0;
	for (c1=0;c1<nV;c1++) if (!mbol->data[c1]) cnt++;
	printf(" (%i not allocated)\n",cnt);		
}

void prepAniCntrl(void) {
	int c1;				
	mvol=new array<float>(1,new int(cntrl->getNumFaces()),0);
	anig=new array<animated*>(1,new int(cntrl->getNumVertices()),NULL);
	for (c1=0;c1<cntrl->getNumFaces();c1++) 
		mvol->data[c1]=shapeVol(face2shape(cntrl,c1));
	for (c1=0;c1<cntrl->getNumVertices();c1++) {
		anig->data[c1]=new particle(cntrl->getVertex(c1)->data);
		*anig->data[c1]->ofric*=1;
	}
	printf("established: << volumes ");
	saveEdges();
	printf("<< edges\n");
};

void aniCntrlUpdate(void) {
	int c1,c2;
	if (!anig) return;
	for (c1=0;c1<anig->numel;c1++) {
		memcpy(&anig->data[c1]->mat->data[12],cntrl->getVertex(c1)->data,12);
		if (cselv->data[c1]&OPT_PROT) *anig->data[c1]->tvel*=0;
		if (cselv->data[c1]&OPT_PROT||cselv->data[c1]/SUB_COLOR)
			anig->data[c1]->setMassAndG(0,0);
			else
			anig->data[c1]->setMassAndG(1,0);
	}
	float Dvol;
	int fl,vi;
	matrix<float> shape;
	matrix<float> cnter(4,1,""),vert(4,1,"");
	glColor3f(1,0,0);
	glPointSize(10);
	glBegin(GL_POINTS);
	for (c1=0;c1<cntrl->getNumFaces();c1++) {
		Dvol=mvol->data[c1]-shapeVol(shape=face2shape(cntrl,c1)); //discrepance		
		fl=cntrl->getFace(c1)->length;		
		memcpy(cnter.data,shape.colmean().data,12);			
		if (-20<Dvol&&Dvol<20) 
			for (c2=0;c2<fl;c2++) {
				vi=cntrl->getFace(c1)->data[c2];
				memcpy(vert.data,cntrl->getVertex(vi)->data,12);
				*anig->data[vi]->tforce+=(vert-cnter)*Dvol*3;
			}
		else glVertex3fv(cnter.data);
	}
	glEnd();
	float err;
	matrix<float> v0(3,1,""),v1(3,1,""),lev;
	for (c1=0;c1<diEd->size[0];c1++) {		
		memcpy(v0[0],cntrl->getVertex(mtEd->data[2*c1+0])->data,12);
		memcpy(v1[0],cntrl->getVertex(mtEd->data[2*c1+1])->data,12);
		lev=v1-v0;
		err=diEd->data[c1]-lev.norm(2);
		*anig->data[mtEd->data[2*c1+0]]->tforce-=lev*err;
		*anig->data[mtEd->data[2*c1+1]]->tforce+=lev*err;
	}	
	for (c1=0;c1<anig->numel;c1++) {		
		anig->data[c1]->motion();
		memcpy(cntrl->getVertex(c1)->data,&anig->data[c1]->mat->data[12],12);
	}
	dirtySubdiv=true;
}

void drawFlag(void) {
	bool turn=true;
	int c1,c2;
	glPushMatrix();
		if ((P->layout->size[1]==1||P->layout->size[1]==2)&&(flag_mode||P->layout->size[1]==2)) {
			matrix<float> iipm=P->getMat();
			glTranslatef(iipm.data[12],iipm.data[13],iipm.data[14]);
			glScalef(.25
							,.25
							,.25);
      if (turn)	glRotatef(toc/11,0,1,0);
		} else {
			glMultMatrixf(A->mat->data);
			glTranslatef(-.45,.2,-.7);	
			if (shot_mode) glTranslatef(-.45,.2,7);
			glScalef(.05
							,.05
							,.05);
			if (turn)	glRotatef(toc/20,0,1,0);
		}
		array<float> flagCol=flagArr;
		for (c1=0;c1<flagArr.size[1];c1++)
			for (c2=0;c2<3;c2++)
				if (!flagArr.data[c1*10+c2]) 
					flagCol.data[c1*10+c2]=selOpt->data[4*currFlag+c2];
		glInterleavedArrays(GL_C4F_N3F_V3F,0,flagCol.data);
		glDrawElements(GL_TRIANGLES,flagInd.numel,GL_UNSIGNED_INT,flagInd.data);
	glPopMatrix();
};