void drawCoord(matrix<float>& wmat) {
	int c1=0;
	float sz=0;
	closeCoord=-1;
	char glt[80];
	matrix<float> v0(4,1,""),v1(4,1,"");
	memcpy(v0.data,&wmat.data[12],12);	
	for (c1=0;c1<asys->numel;c1++)
		if (asys->data[c1]->opt) {
			sprintf(glt,"%i",c1);
			memcpy(v1.data,&asys->data[c1]->getMat().data[12],12);
			glCout.space(v1.data,glt,fnt1);			
			asys->data[c1]->draw(true);
			glPushMatrix();            				
				glMultMatrixf(asys->data[c1]->getMat().data);				
				glColor3fv(&selOpt->data[4*c1]);				
				sz=.15;
				if ((v0-v1).norm(2)<.3&&flag_mode&&P->layout->size[1]==1) {
					if (c1!=currFlag) closeCoord=c1; else
						if (closeCoord<0) closeCoord=-2;					
					matrix<float> force=((animated*)P->carrier)->mat->glInverse()*(v0-v1);
					P->glForceAdd+=gstVector(force.data[0],force.data[1],force.data[2])*1;
					sz=.3;
				}
				glutSolidSphere(sz,10,10);							
			glPopMatrix();			
		}
}


void loadMesh(void) {
	int c1,nV;
	matrix<float> saveV((*locat+".mv3").str);
	if (!saveV.data) return;
	if (cntrl) delete cntrl;
	cntrl=new AdaptiveMesh();	
	Vertex v(4);
	nV=saveV.size[1];
	for (c1=0;c1<saveV.size[1];c1++) {
		memcpy(v.data,saveV[c1*3],12);
		cntrl->addVertex(&v); };
	array<int> 		saveF((*locat+".mfs").str);
	int cnt=0,fl;
	while (fl=saveF.data[cnt]) {
		Face f(fl); cnt++;
		memcpy(f.data,saveF[cnt],fl*4); cnt+=fl;
		cntrl->addFace(&f);
	}
	array<float> olok((*locat+".mlo").str);
	memcpy(A->mat->data,olok.data,16*4);
	matrix<int> gtxm((*locat+".xmi").str);
	*xmirror=gtxm;	
	matrix<int> gatr((*locat+".atr").str);
	if (gatr.data) {
		for (c1=0;c1<nV;c1++) cselv->data[c1]=0;
		memcpy(cselv->data,gatr.data,nV*4);
		cout << gatr; }		
	matrix<int> gcsf((*locat+".csf").str);
	if (gcsf.data) *cself=gcsf;	
	array<int> cdomS((*locat+".dom").str);	
	if (cdomS.data) { //reading in coordinate system
		array<float> csysS((*locat+".sys").str);		
		int par;
		for (c1=0;c1<cdomS.numel;c1++) {
			asys->data[c1]->opt=cdomS.data[c1]&SUB_CARRIER-1;
			memcpy(asys->data[c1]->mat->data,&csysS.data[16*c1],64);
			par=cdomS.data[c1]/SUB_CARRIER;
			if (par) asys->data[c1]->carrier=asys->data[par];
		}
	}	
};

void saveMesh(Mesh *msh) {
	int c1,c2;
	int nV=msh->getNumVertices();
	matrix<float> saveV(3,nV,"");
	for (c1=0;c1<nV;c1++)
		memcpy(saveV[c1*3],msh->getVertex(c1)->data,12);
	saveV.store((*locat+".mv3").str);		
	int cnt=0,fl;
	array<int> saveF(1,new int(8*msh->getNumFaces()+1),0);
	for (c1=0;c1<msh->getNumFaces();c1++) {
		fl=msh->getFace(c1)->length;
		saveF.data[cnt]=fl; cnt++;
		memcpy(saveF[cnt],msh->getFace(c1)->data,fl*4); cnt+=fl;
	};	
	saveF.store((*locat+".mfs").str);    //faces
	A->mat->store((*locat+".mlo").str);  //faces
	xmirror->store((*locat+".xmi").str); //mirror options
	array<int> saveP(1,&nV,0);
	memcpy(saveP[0],cselv->data,4*nV);
	saveP.store((*locat+".atr").str);   //masses	
	cself->store((*locat+".csf").str);   //faces	
	if (nV) saveEdges();
	if (mbar) mbar->store((*locat+".bar").str);	
	int size[3];
	size[0]=4; size[1]=4; size[2]=selOpt->size[1];
	array<float> asysMat(3,size,0);
	array<int>   asysOpt(1,&size[2],0);	
	for (c1=0;c1<asys->numel;c1++)
		if (asysOpt.data[c1]=asys->data[c1]->opt) {
			if (asys->data[c1]->carrier) {
				printf("...");
				for (c2=0;c2<asys->numel;c2++) 
					if (asys->data[c2]==asys->data[c1]->carrier) {
						printf("%i parent of %i\n",c2,c1);						
						asysOpt.data[c1]|=c2*SUB_CARRIER;
					}				
			}
			memcpy(&asysMat.data[16*c1],asys->data[c1]->mat->data,64);
		}
	asysMat.store((*locat+".sys").str);   //masses	
	asysOpt.store((*locat+".dom").str);   //masses	
}
