#include "AdaptiveMesh.h"

AdaptiveMesh::AdaptiveMesh ( ) : Mesh ( )
{
	vertices = new AdaptiveArray<Vertex> ( 128 );
	faces = new AdaptiveArray<Face> ( 128 );
}

AdaptiveMesh::~AdaptiveMesh ( void )
{
	delete vertices;
	delete faces;
}

int AdaptiveMesh::getNumFaces ( void )
{
	return faces->getSize ( );
}

int AdaptiveMesh::getNumVertices ( void )
{
	return vertices->getSize ( );
}

int AdaptiveMesh::addFace ( Face* face )
{
	int index = faces->getNewElement ( );

	(faces->getElement ( index )).copy ( face );

	return index;
}

Face* AdaptiveMesh::getFace ( int i )
{
	return &faces->getElement ( i );
}

int AdaptiveMesh::addVertex ( Vertex *vertex )
{
	vertices->insertElement ( *vertex );

	return getNumVertices ( ) - 1;
}

Vertex* AdaptiveMesh::getVertex ( int i )
{
	return &vertices->getElement ( i );
}

ArrayMesh *AdaptiveMesh::toArrayMesh ( void )
{
	int i;
	ArrayMesh *rvalue = new ArrayMesh ( getNumFaces ( ), getNumVertices ( ) );

	for ( i = 0; i < getNumFaces ( ); i++ )
	{
		rvalue->addFace ( getFace ( i ) );
	}

	for ( i = 0; i < getNumVertices ( ); i++ )
	{
		rvalue->addVertex ( getVertex ( i ) );
	}

	return rvalue;
}

