#include <string.h>
#include "ArrayMesh.h"
#include <assert.h>

ArrayMesh::ArrayMesh ( int numFaces, int numVertices ) : Mesh ( )
{
	totalFaces = numFaces;
	totalVerts = numVertices;
	
	vertices = new Vertex [ totalVerts ];
	faces = new Face [ totalFaces ];

	this->numFaces = 0;
	this->numVerts = 0;

	assert ( numFaces >= 0 );
}

ArrayMesh::~ArrayMesh ( void )
{
	assert ( numFaces >= 0 );
	delete[] vertices;
	delete[] faces;
}

int ArrayMesh::getNumFaces ( void )
{
	assert ( numFaces >= 0 );
	return numFaces;
}

int ArrayMesh::getNumVertices ( void )
{
	assert ( numFaces >= 0 );
	return numVerts;
}

int ArrayMesh::addFace ( Face* face )
{
	assert ( numFaces >= 0 );
	//if ( numFaces >= totalFaces ) {
		//printf("requested %i of %i",);
		//}
	assert ( numFaces < totalFaces );

	Face *stored = getFace ( numFaces++ );

	stored->copy ( face );

	return numFaces - 1;
}

Face* ArrayMesh::getFace ( int i )
{
	assert ( numFaces >= 0 );
	assert ( i >= 0 && i < totalFaces );
	return &faces [ i ];
}

int ArrayMesh::addVertex ( Vertex *vertex )
{
	assert ( numFaces >= 0 );
	assert ( numVerts < totalVerts );

	Vertex *vert = getVertex ( numVerts++ );

	*vert = *vertex;

	return numVerts - 1;
}

Vertex* ArrayMesh::getVertex ( int i )
{
	assert ( i >= 0 && i < totalVerts );
	assert ( numFaces >= 0 );
	return &vertices [ i ];
}
