#include <windows.h>
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <iostream.h>
#include "..\ntree.h"
#include "..\matrix.h"
#include "..\string.h"

#define pi 3.14159265

#define KEY_ST     0
#define KEY_SP     256
#define KEY_DOWN   256*2
#define KEY_MODIFY 256*4
#define KEY_left   KEY_SP+100
#define KEY_right  KEY_SP+102
#define KEY_up     KEY_SP+101
#define KEY_down   KEY_SP+103

int tic=0,toc,frames,ftic;
int frame_v,frame_w=640,frame_h=480,frame_w2,frame_h2;
float dt,dt2;
matrix<float> project(4,4,"");
matrix<int> keys(256,5,"");
int mouse[7];
bool fscreen=false,modes[4];
array<unsigned char> *fnt0,*fnt1; //courier 7x11 bold

#include "..\glLabel.h"
glLabel glCout;

void main_ (int argc,char** argv);
void display_ (void);
void drawOneString(int x,int y,char *txt); //we dont need that?

void display(void) {	
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	dt=(clock()-toc)*.001; dt2=dt*dt;	
	toc=clock(); frames++;
	if (ftic+1000<toc) {ftic=toc; frame_v=frames; frames=0;}	
	char dtc[10]; sprintf(dtc,"%i@%i",frame_v,toc/1000);
	linked_label.append(new glLabelText(0,0,dtc,fnt1));	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	display_();
	glCout.flush();
	glFlush(); glutSwapBuffers();		
	//keys.data[32]=1;
	//memcpy(&keys.data[KEY_ST],zeros_int,1024);
	memcpy(&keys.data[KEY_ST+KEY_DOWN],zeros_int,1024);
	memcpy(&keys.data[KEY_SP+KEY_DOWN],zeros_int,1024);
};

void redisplay(void) {glutPostRedisplay();}
void keyboard(unsigned char key,int x,int y) {	
	int m=glutGetModifiers();	
	if (key==27) exit(0);
	if (keys.data[KEY_ST+103]) {//opengl control mode
		if (key==102) //flat shade
			if (modes[1])  {modes[1]=false; glShadeModel(GL_SMOOTH);}
								else {modes[1]=true;  glShadeModel(GL_FLAT);};
		if (key==115) {//saving
			int size[3];
			size[0]=4; size[1]=frame_w; size[2]=frame_h;
			array<unsigned char> pixels(3,size,0);
			glReadPixels(0,0,frame_w,frame_h,GL_RGBA,GL_UNSIGNED_BYTE,pixels.data);
			pixels.store("data\\pixels.dat");}
		if (key==119) //wireframe
			if (modes[0])  {modes[0]=false; glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);}
								else {modes[0]=true;  glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);};
	}
	keys.data[key+KEY_ST]=1;
	keys.data[key+KEY_ST+KEY_DOWN]=1;
	keys.data[key+KEY_MODIFY]=m;	
	printf("down %i %i\n",key,m);
};
void keyboardUp(unsigned char key,int x,int y) {	
	if (key==27) exit(0);	
	keys.data[key+KEY_ST]=0;
	keys.data[key+KEY_MODIFY]=0;	
};
void special(int key,int x,int y) {	
	int m=glutGetModifiers();
	keys.data[key+KEY_SP]=1;
	keys.data[key+KEY_SP+KEY_DOWN]=1;
	keys.data[key+KEY_MODIFY]=m;	
	printf("spec %i %i\n",key,m);
};
void specialUp(int key,int x,int y) {
	keys.data[key+KEY_SP]=0;
	keys.data[key+KEY_MODIFY]=0;
};
void mousefunc(int b,int s,int x,int y) {
	int c1;
	if (b==0)
		if (s==0)	{
			mouse[0]=0; //delta
			mouse[1]=0;
			mouse[2]=y; //actual
			mouse[3]=x;
			mouse[4]=y; //mouse offset
			mouse[5]=x;
			mouse[6]=1;}
		else
			for (c1=0;c1<7;c1++) mouse[c1]=0;
};
void motion(int x,int y) {	
	if (mouse[6]) {
		mouse[0]=y-mouse[2];
		mouse[1]=x-mouse[3];
		mouse[2]=y;
		mouse[3]=x;};
};
void passivemotion(int x,int y) {/*printf("%i %i \r",x,y);*/};
void entry(int s) {
	if (!s) exit(0);
};
void reshape(int framew,int frameh) {	
	float p[16];
	frame_w =framew;		frame_h =frameh;	
	frame_w2=framew*.5; frame_h2=frameh*.5;
	glViewport (0,0,frame_w,frame_h);
	glMatrixMode(GL_PROJECTION);						//matrices
		glLoadIdentity();
		gluPerspective(55,frame_w/(float)frame_h,.1,1000);
		glGetFloatv(GL_PROJECTION_MATRIX,p);
		memcpy(project.data,p,4*16);		
	display();
};

int main (int argc,char** argv) {
	int c1;	
	glutInit(&argc,argv);										//opengl window
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_DEPTH|GLUT_RGBA);	
	if (!fscreen) {
		glutInitWindowPosition(510,40);
		glutInitWindowSize(frame_w,frame_h);		
		glutCreateWindow("Jaya");
	} else {
		glutGameModeString("1152x864:32@75");
		if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) glutEnterGameMode();
	};
	glutDisplayFunc(display);								//callbacks
		glutIdleFunc(redisplay);
		glutKeyboardFunc(keyboard);
		glutKeyboardUpFunc(keyboardUp);
		glutSpecialFunc(special);
		glutSpecialUpFunc(specialUp);
		glutMouseFunc(mousefunc);
		glutMotionFunc(motion);
		glutPassiveMotionFunc(passivemotion);
		glutEntryFunc(entry);
		glutReshapeFunc(reshape);
		glutIgnoreKeyRepeat(1);	
	glMatrixMode(GL_PROJECTION);						//matrices
		gluPerspective(55,1.5,.1,3000);				
	glClearColor(0,0,0,0);								//background
	glShadeModel(GL_SMOOTH);							//GL_FLAT
	glEnable(GL_DEPTH_TEST);							//depthtest
		glDepthFunc(GL_LESS);
	glClearColor(.2,.2,.2,0);
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);     //texture
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);		
	//glEnable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);	
	glDisable(GL_BLEND);										//blending
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);

	//float light_col[]={1.,1.,1.,1.},light_amb[]={.05,.05,.05,1.},light_spc[]={.5,.5,.5,1};
	float light_col[]={1.,1.,1.,1.},light_amb[]={.05,.05,.05,1.},light_spc[]={.5,.5,.5,1};
	glEnable(GL_COLOR_MATERIAL);
	//glColorMaterial(GL_LIGHT_MODEL_TWO_SIDE,GL_AMBIENT_AND_DIFFUSE);
	glColorMaterial(GL_FRONT_AND_BACK,GL_DIFFUSE);
	glLightfv(GL_LIGHT0,GL_AMBIENT,light_amb);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,light_col);
	glLightfv(GL_LIGHT0,GL_SPECULAR,light_spc);
	//glLightModelfv(GL_LIGHT_MODEL_AMBIENT,light_amb);	
	glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,1.0);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);		
		
	float fog_color[4]={.3,.3,.3,1.};
	//glEnable(GL_FOG);
		glFogfv(GL_FOG_COLOR,fog_color);	
		glFogf(GL_FOG_DENSITY,.01);
	//glEnable(GL_LINE_SMOOTH);
	//glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);
	
	//printf("%i",ROUND(-.7)); exit(0);
	arrays();
	fnt0=new array<unsigned char>("data\\courier.fnt");
	main_(argc,argv);
	glutMainLoop(); return 0;
}

float frandSin(double seed) {
  static double drandSin_cnt;
  float t0=sin(++drandSin_cnt+seed)*1e4;
  return t0-floor(t0);
};
float limited(float fval,float fmin,float fmax) {
	if (fval<fmin) return fmin;
	if (fval>fmax) return fmax;
	return fval;
};
float norm(float *v,int l) {
	int c1;
	float n=0;
	for (c1=0;c1<l;c1++) n+=v[c1]*v[c1];
	return sqrt(n);
};
void matrixdsp(float *a,int n) {
	int c1,c2,c3;
	for (c3=0;c3<n;c3++) { printf("  slide %i\n",c3);
	for (c1=0;c1<4;c1++) {
		for (c2=0;c2<4;c2++) printf("%13.7f",a[c3*16+c2*4+c1]);
		printf("\n"); }
	printf("-------------------------------------\n"); }
};
void loadTex(GLuint hnd,char *fn) {	
	array<unsigned int> tex(fn);
	glBindTexture(GL_TEXTURE_2D,hnd);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,tex.size[1],tex.size[2],0,GL_RGBA,GL_UNSIGNED_BYTE,tex.data);
}

unsigned int newList(unsigned int hnd,char *fn,unsigned int tex,matrix<float> mat) {
	//change mat to *mat an accept NULL for ID Matrix so dont push
	int c1,cnt=0;
	array<float>				arr(((string)fn+".arr").str);
	array<unsigned int> ind(((string)fn+".ind").str);	
	unsigned int list;
	if (arr.size[0]== 6) list=GL_C3F_V3F;
	if (arr.size[0]==10) list=GL_C4F_N3F_V3F;
	glNewList(hnd,GL_COMPILE);	
		glPushMatrix();
			glMultMatrixf(mat.data);
			glInterleavedArrays(list,0,arr.data);
			if (tex) {glEnable(GL_TEXTURE_2D); glBindTexture(GL_TEXTURE_2D,tex); }
			if      (ind.size[0]==2) //GL_QUAD_STRIP
				for (c1=0;c1<arr.size[2]-1;c1++)
					glDrawElements(GL_QUAD_STRIP,2*arr.size[1],GL_UNSIGNED_INT,&ind.data[c1*2*arr.size[1]]);
			else if (ind.size[0]==3) //GL_TRIANGLES
				glDrawElements(GL_TRIANGLES,ind.numel,GL_UNSIGNED_INT,ind.data);		
			if (tex) glDisable(GL_TEXTURE_2D);
		glPopMatrix();
	glEndList();
	cout << " \\- drawlist: #" << hnd << " tex:" << tex << " list:" << list << endl;
	return hnd;
};
