#include <gstPHANToM.h>
#include <gstDeviceIO.h>

#include "..\opengl.h"
#include "..\timer.h"
#include "..\fmSound.h"
fmSound sound;
#define ANI_DELAY
#include "..\aniava.h"
#include "..\jPhantom.h"

jPhantom *P;
GST_SCHEDULER_CALLBACK servoLoop(void *null) {
	int c1,c2;
	P->update();
	if (P->force.norm()>4.3) P->force=P->force.normalize()*4.3;
	gstSetPhantomForce(P->ghost,P->force);
	return 0;
};

#define CYCLES 300
array<int> *rndb; array<float> *rndu,*rndn;
array<unsigned int> flagInd("data\\flag0.ind");
array<float> flagArr("data\\flag0.arr");

matrix<float> *cycle;
linked<animated*> linked_ani;
avatar *A;

unsigned int p_layout[5],common_tex[4],common_list[4];
FSOUND_SAMPLE *common_smp[10];
matrix<int> *xmirror;
string *locat;
array<animated*> *anig;
bool model_mirror=false,flag_mode=false,shot_mode=false,quality=false,interpol=false;

bool jayaDeform;
int currShape=0, currCarrier=-1, currConnect=-1,currFlag=0;
int maxFrame=0,currFrame=0;
bool dirtyNormals=true, dirtySubdiv=true, currWabble=false;

matrix<float> *currScale,*colOpt,*selOpt,*matModel;
matrix<int> *currOpt,*currDepth;

#include "include.cpp"

void setDefaults(void) {		
		*A->mat=matrix<float>(4,4,"eye");
		A->mat->data[12]=0;
		A->mat->data[13]=2;
		A->mat->data[14]=10;
}

void main_(int argc,char** argv) {
	int c1,c2,cnt=0,ofs;
	locat=new string;
	*locat=(string)("data\\")+(string)(argv[1]);
	printf("Retrieving model info in %s.*\n",locat->str);	

	fnt1=new array<unsigned char>("data\\solid.fnt");
	rndb=new array<int>("data\\rndb.tab");		//random numbers
	rndu=new array<float>("data\\rndu.tab");
	rndn=new array<float>("data\\rndn.tab");
	cycle=new matrix<float>(CYCLES,1,"fill");
	*cycle*=(1/(float)CYCLES)*2*M_PI;
	init();
	//sound.music(false);
	float light_col[]={.5,.5,.5,.5};
	glLightfv(GL_LIGHT1,GL_DIFFUSE,light_col);
	glLightfv(GL_LIGHT1,GL_SPECULAR,light_col);
	//glEnable(GL_LIGHT1);
	glDisable(GL_LIGHT1);
	glLightfv(GL_LIGHT2,GL_DIFFUSE,light_col);
	glLightfv(GL_LIGHT2,GL_SPECULAR,light_col);
	glEnable(GL_LIGHT2);
	glDisable(GL_LIGHT2);

	A=new avatar();										//avatar init...
		setDefaults();
		linked_ani.append(A);

	P=new jPhantom(4);									//phantom init...
		P->layout->data[0]=jPhantom_listGstPtr1(glGenLists(1));
		P->layout->data[1]=newList(glGenLists(1),"data\\hand0",0,glScale(1,1,1));
		P->layout->data[2]=newList(glGenLists(1),"data\\feather",0,glScale(1,1,1));
		P->layout->data[3]=newList(glGenLists(1),"data\\bulb",0,glScale(1,1,1));
		P->layout->size[1]=1;		
		P->carrier=A;
		P->setMode(2);
		gstInitServoScheduler();
  	gstStartServoScheduling(servoLoop,NULL);
  	linked_ani.append(P);
  	P->control(true);

	currScale=new matrix<float>(80,1,"fill");
	*currScale*=.15; *currScale+=.3; currScale->size[2]=25;
	currOpt=new matrix<int>(3,1,"");
	currOpt->record(OPT_PROT);
	currOpt->record(OPT_XMIR);
	currOpt->record(OPT_YZPR);
	colOpt=new matrix<float>("data\\opt.c");
	selOpt=new matrix<float>("data\\sel.c");
	//cout << *colOpt; exit(0);
	currDepth=new matrix<int>(6,1,"fill"); //currDepth->size[2]=1;
	xmirror=new matrix<int>(2,60,""); *xmirror-=1;
	cntrl=new AdaptiveMesh();
	cselv=new array<int>(1,new int(1000),0);
	cself=new array<int>(1,new int(1000),0);
  matModel=new matrix<float>(4,4,"eye");
 	marr=new array<float>				 ((*locat+".arr").str);
	mact=new array<float>				 ((*locat+".arr").str);
	mind=new array<unsigned int> ((*locat+".ind").str);
	jayaDeform=marr->data&&mind->data;
	if (jayaDeform) {
		mbar=NULL;
		mbol=new array<bool>	       (1,&marr->size[1],false); //true if subdiv covers vert
		mext=new matrix<float>			 (4,2,"");
	}
	cout << SEPR;	
};

void display_(void) {
	int c1,c2,c3,cnt=0;
	animated* ani;	
	for (c1=0;c1<4;c1++) if (keys.data[KEY_SP+KEY_DOWN+c1+9]) P->layout->size[1]=c1;
	glEnable(GL_LIGHTING);
	A->control(true);	
	P->control(false);
	while (linked_ani.token(ani)) ani->motion();	
	linked_ani.token(ani);
	if (0) {//crosshair
		glPushMatrix();
			matrix<float> rot(4,4,"eye");
			memcpy(rot.data,ani->mat->glInverse().data,48);
			glTranslatef(-.5,.3,-1);
			glMultMatrixf(rot.data);
			glLineWidth(1);
			glBegin(GL_LINES);
				glNormal3f(0,1,0);
				glColor3f(1,0,0); glVertex3f(0,0,0); glVertex3f(.1, 0, 0);
				glColor3f(0,0,0); glVertex3f(0,0,0); glVertex3f( 0,.1, 0);
				glColor3f(0,0,1); glVertex3f(0,0,0); glVertex3f( 0, 0,.1);
			glEnd();			
		glPopMatrix();
	}		
	glMultMatrixf(ani->mat->glInverse().data);
	
	matrix<float> d(4,1,""); d.data[1]=1; glLightfv(GL_LIGHT0,GL_POSITION,d.data); //head light
	float alpha=cycle->token();
	d.data[0]=cos(alpha); d.data[1]=0; d.data[2]=sin(alpha);
	glLightfv(GL_LIGHT1,GL_POSITION,d.data); //rotating light	
	
	while (linked_ani.token(ani)) {
		glPushMatrix();
			glMultMatrixf(ani->getMat().data);
			ani->draw(false);
		glPopMatrix(); }

	if (shot_mode) glClearColor(0,0,0,0);
	else {
		glClearColor(.2,.2,.2,0);
		if (1) {//axis
			glNormal3f(0,1,0);
			glColor3f(.7,.4,0); glLineWidth(2);	glBegin(GL_LINES);
				glVertex3f(-20,  0,  0); glVertex3f( 20,  0,  0);
				glVertex3f(  0,-20,  0); glVertex3f(  0, 20,  0);
				glVertex3f(  0,  0,-20); glVertex3f(  0,  0, 20);	glEnd();}
		if (1) {//floor
			glColor4f(.4,.4,.4,.3); glBegin(GL_QUADS);
				glVertex3f(-100,-80, 100);
				glVertex3f( 100,-80, 100);
				glVertex3f( 100,-80,-100);	
				glVertex3f(-100,-80,-100); glEnd();}
		if (1) {//mesh
			glColor4f(.3,.7,.3,.3); glLineWidth(1); glBegin(GL_LINES);		
			for (float x=-30;x<30;x+=2) {
				glVertex3f(-30,0,  x); glVertex3f( 30,0,  x);
				glVertex3f(  x,0,-30); glVertex3f(  x,0, 30);
			}
			glEnd();
		}
	}	
//serious code end----------------------------------------------------------------	
	if (keys.data['/'])
		for (c1=0;c1<10;c1++) {
			if (keys.data['0'+c1+KEY_DOWN]) currFlag=c1;
			keys.data['0'+c1+KEY_DOWN]=0;
		}

	drawFlag(currFlag);
	
	char glt[80];
	matrix<float> pmat=P->getMat();
	sprintf(glt,"%6.2f,%6.2f,%6.2f",pmat.data[12],pmat.data[13],pmat.data[14]);
	linked_label.append(new glLabelText(frame_w-150,frame_h-22,glt,fnt1));	

	timer::singleton()->resetTime(0);
	glLightfv(GL_LIGHT2,GL_POSITION,&P->getMat().data[12]);
	if (jayaDeform) { //draw model
		if (keys.data[' ']&&mbar) {						//highlight verts without bari coordinate alloc
			for (c1=0;c1<mbol->numel;c1++)
				if (mbol->data[c1]) {
					mact->data[10*c1+0]=0; mact->data[10*c1+1]=.3; mact->data[10*c1+2]=0;
				} else {
					mact->data[10*c1+0]=1; mact->data[10*c1+1]= 0; mact->data[10*c1+2]=0;
				}
			dirtySubdiv=true;
		}
		float ff[]={.5,.5,.5,1};
		glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,ff);
		glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,10);
		glInterleavedArrays(GL_C4F_N3F_V3F,0,mact->data);
		glDrawElements(GL_TRIANGLES,mind->numel,GL_UNSIGNED_INT,mind->data); }				
	glDisable(GL_LIGHTING);	glDisable(GL_LIGHT2);

	//***
	sprintf(glt,"drwmodel: %f",timer::singleton()->resetTime(0));
	linked_label.append(new glLabelText(0,frame_h-55,glt,fnt1));	
	
	if (keys.data[KEY_GHOST]) {//circle around phantom pointer
		if (cnt=keys.data[KEY_right]-keys.data[KEY_left]) {
			*A->tvel*=0;
			matrix<float> art(3,1,""); //memcpy(art[0],&A->mat->data[4],12);//
			art.data[1]=1;			
			*A->mat=glTranslate(&pmat.data[12])*glRotation((art*.05*cnt).data)*glTranslate(-pmat.data[12],-pmat.data[13],-pmat.data[14])**A->mat;
		}
		if (cnt=keys.data[KEY_SP+105]-keys.data[KEY_SP+104]) {
			*A->tvel*=0;
			matrix<float> art(3,1,""); memcpy(art[0],&A->mat->data[0],12);
			*A->mat=glTranslate(&pmat.data[12])*glRotation((art*.05*cnt).data)*glTranslate(-pmat.data[12],-pmat.data[13],-pmat.data[14])**A->mat;
		}
	}	
	sprintf(glt,"frame: %i/%i",currFrame,maxFrame);
	linked_label.append(new glLabelText(0,frame_h-44,glt,fnt1));	
	if (keys.data['.']) {
		currFrame+=keys.data['+'+KEY_DOWN]-keys.data['-'+KEY_DOWN];
		if (keys.data[13+KEY_DOWN]) dirtySubdiv=loadFrame();
		keys.data[13+KEY_DOWN]=0;
		//currFrame=MAX(MIN(currFrame,maxFrame),0);
	} else
		if ((c1=keys.data['+'+KEY_DOWN]-keys.data['-'+KEY_DOWN])&&!currShape&&cntrl->getNumFaces()) {currDepth->token(c1); dirtySubdiv=true; *A->tvel*=0;}
	
	if (keys.data[13+KEY_DOWN]) {
		flag_mode=!flag_mode;
	}
	
	
	
	
	matrix<float> w;
	switch (P->layout->size[1]) { //interpret phantom--------------------------------------
  case 0: { //control point move / new face generate
 		glEnable(GL_BLEND);
		glDepthMask(GL_FALSE); 
  	sprintf(glt,"(5)tetra :: (6)octa"); linked_label.append(new glLabelText(10,frame_h-22,glt,fnt1));
  	if (keys.data['0'+KEY_DOWN]) currShape=0;
  	if (keys.data['5'+KEY_DOWN]) currShape=5;
  	if (keys.data['6'+KEY_DOWN]) currShape=6;  	
  	if (currShape) {
	  	sprintf(glt," :: (0)deselect"); linked_label.append(new glLabelText(150,frame_h-22,glt,fnt1));
	  	sprintf(glt,"+/- for shape size "); linked_label.append(new glLabelText(10,frame_h-33,glt,fnt1));
			float sS=currScale->token(keys.data['+']-keys.data['-']);
			matrix<float> selS=pmat*glScale(sS,sS,sS)**base[currShape];
			//matrix<float> selS=*base[currShape]; //at origin			
			//for (c1=0;c1<selS.size[1];c1++) {sprintf(glt,"%i",c1);glCout.space(selS[c1*4],glt,fnt1); }						
			selS.size[2]|=3|SUB_SELECT;
			for (c1=0;c1<selS.size[1];c1++)	findClosest(cntrl,selS[c1*4],.2,cnt,true);
			drawShape(selS);
			if (keys.data[KEY_GHOST+KEY_DOWN]== 1) {addShape(cntrl,selS,.2); dirtySubdiv=true;} //eo button down!
			if (keys.data[KEY_GHOST+KEY_DOWN]==-1) //keep shape when draggen out else no shape
	  		for (c1=0;c1<cntrl->getNumFaces();c1++)
  				if (bary(face2shape(cntrl,c1),&pmat.data[12],w)) currShape=0;
	  } else { //no currShape
  		matrix<float> shp;
  		for (c1=0;c1<cntrl->getNumFaces();c1++) { //if P in shape => highlight
	  		shp=face2shape(cntrl,c1);
  			if (bary(shp,&pmat.data[12],w)) {
	  			shp.size[2]|=SUB_SELECT;
	  			drawShape(shp);
  			}
			}

			findClosest(cntrl,&pmat.data[12],.5,cnt,true); //attract by vertex
			if (keys.data[KEY_GHOST+KEY_DOWN]==1) { //add primitive
				currConnect=-1;
				currCarrier=-1;				
	  		for (c1=0;c1<cntrl->getNumFaces();c1++) { //detect face grabbing
			  	shp=face2shape(cntrl,c1);
  				if (bary(shp,&pmat.data[12],w)) {
						array<int> si=w.sort();
						if (w.data[w.numel-1]<.8) { //away from vertex
							for (c2=0;c2<w.size[0]-3;c2++) w.data[c2]=0;
							Face f(4);
							Vertex v(4);
							memcpy(v.data,&pmat.data[12],16);
							for (c2=0;c2<3;c2++)
								f.data[c2]=cntrl->getFace(c1)->data[si.data[w.size[0]-3+c2]];
							currCarrier=cntrl->addVertex(&v);
							f.data[3]=f.data[1];
							f.data[1]=f.data[2];
							f.data[2]=f.data[3];
							f.data[3]=currCarrier;					
							cself->data[cntrl->getNumFaces()]=currFlag;
							cntrl->addFace(&f);							
							break;
						}
					}
				}
				if (currCarrier<0) findClosest(cntrl,&pmat.data[12],.5,currCarrier,true); //if face grabbing not succesful, grabb vertex?
  		}
			if (keys.data[KEY_GHOST]&&currCarrier>=0)
				if (cselv->data[currCarrier]&OPT_PROT) {} else {
				float away[]={100,100,100};
				memcpy(cntrl->getVertex(currCarrier)->data,away,12); //simulate curr vertex way off such that
				if (findClosest(cntrl,&pmat.data[12],.3,currConnect,true)) { //...attraction by 2nd vertex is possible
					glColor3f(1,1,0);
					glPushMatrix();
						glTranslatef(cntrl->getVertex(currConnect)->data[0],
												 cntrl->getVertex(currConnect)->data[1],
												 cntrl->getVertex(currConnect)->data[2]);
						glutSolidSphere(.1,10,10);
					glPopMatrix();
				}
				memcpy(cntrl->getVertex(currCarrier)->data,pmat[12],12); //reposition grabbed vertex
				for (c1=0;c1<cntrl->getNumFaces();c1++)
					if (cntrl->getFace(c1)->length==4) orientFace(cntrl,c1);
				dirtySubdiv=true;
			};
			if (keys.data[KEY_GHOST+KEY_DOWN]==-1) {
				if (currConnect>=0) {//dragging has caused connection				
					twoConnect(currConnect,currCarrier);
					currConnect=-1;
					dirtySubdiv=true;
				}								
				currCarrier=-1;				
			}
		} //eo no shape -> so drag and drop
		glDisable(GL_BLEND);
		glDepthMask(GL_TRUE);
	
	} break; //eo case 0
	case 1: { //control point select / face select / do some magic
		sprintf(glt,"(l)oad :: (s)ave :: (b)ary. coord."); linked_label.append(new glLabelText(10,frame_h-22,glt,fnt1));
		for (c1=0;c1<10;c1++)
			if (keys.data['0'+c1+KEY_DOWN]) currFlag=c1;
		if (flag_mode) {
			sprintf(glt,"0-6 partition"); linked_label.append(new glLabelText(10,frame_h-33,glt,fnt1));
  		matrix<float> shp;
 			glEnable(GL_BLEND);
			glDepthMask(GL_FALSE);
  		for (c1=0;c1<cntrl->getNumFaces();c1++) { //if P in shape => highlight
	  		shp=face2shape(cntrl,c1);
  			if (bary(shp,&pmat.data[12],w)) {
	  			shp.size[2]|=SUB_COLOR*currFlag|SUB_SELECT;
	  			drawShape(shp);
	  			if (keys.data[KEY_GHOST]) cself->data[c1]=currFlag;
  			}
			}
 			glDisable(GL_BLEND);
			glDepthMask(GL_TRUE);
			if (keys.data[KEY_GHOST+KEY_DOWN]) {cout << *cself;}
		} else {
			if (!findClosest(cntrl,&pmat.data[12],.5,cnt,true)) { //if in free space tokenize		
				if (currCarrier<0) {sprintf(glt,"click to toggle options"); linked_label.append(new glLabelText(10,frame_h-33,glt,fnt1));}
				switch (currOpt->cycle(keys.data[KEY_GHOST+KEY_DOWN]==1)) { // line is wow!!!
					case OPT_PROT: glCout.space(&pmat.data[12],"protect",fnt1); break;
					case OPT_XMIR: glCout.space(&pmat.data[12],"x-mirror",fnt1); break;
					case OPT_YZPR: glCout.space(&pmat.data[12],"yz-project",fnt1); break;
				}
			}
		
			if (keys.data[KEY_GHOST+KEY_DOWN]==1) { //select/unselect (the beginning of something wonderful)
				currCarrier=-1;
				currConnect=-1;
				if (findClosest(cntrl,&pmat.data[12],.5,currCarrier,false)) {
					dirtySubdiv=true;
					if (currOpt->cycle(0)==OPT_PROT) cselv->data[currCarrier]^=OPT_PROT;
					if (currOpt->cycle(0)==OPT_XMIR) removeMirror(currCarrier);
					if (currOpt->cycle(0)==OPT_YZPR) cselv->data[currCarrier]^=OPT_YZPR;
				}
			}
			if (keys.data[KEY_GHOST]&&currCarrier>=0) { //are you carrying something ?
				if (currOpt->cycle(0)&OPT_XMIR) { //draw line to phantom
					matrix<float> tmpv(3,1,""); memcpy(tmpv.data,cntrl->getVertex(currCarrier)->data,12);
					matrix<float> tmpp(3,1,""); memcpy(tmpp.data,&pmat.data[12],12);
					glColor3f(1,1,0); glLineWidth(4);
					glBegin(GL_LINES); glVertex3fv(tmpv[0]); glVertex3fv(tmpp[0]); glEnd();
					sprintf(glt,"%6.3f",(tmpv-tmpp).norm(2));
					glCout.space(((tmpv+tmpp)*.5).data,glt,fnt1);      	
					if (findClosest(cntrl,&pmat.data[12],.3,currConnect,true))  //attract by 2nd vertex and highlight
						{};//cselv->data[currConnect]|=OPT_HIGH;
				}
			}
			if (keys.data[KEY_GHOST+KEY_DOWN]==-1&&currCarrier>=0) {
				if (currOpt->cycle(0)&OPT_XMIR&&currConnect>=0)
					if (currCarrier!=currConnect) { //finaly we make 'em a pair
						removeMirror(currCarrier);
						removeMirror(currConnect);
						addMirror(currConnect,currCarrier);
					}
				currCarrier=-1; currConnect=-1;
			}
		}
		//MIRROR
		//if (keys.data['1'+KEY_DOWN]&&!model_mirror) {model_mirror=true;	addMirror(); dirtySubdiv=true; }
	} break; //eo case 1 (hand)
	case 2: {//transform all the cntrl vertices
		sprintf(glt,"(b)arycentric"); linked_label.append(new glLabelText(10,frame_h-22,glt,fnt1));
		for (c1=0;c1<10;c1++)
			if (keys.data['0'+c1+KEY_DOWN]) currFlag=c1;
		matrix<float> tvrt(4,1,"ones");
		if (keys.data[KEY_GHOST+KEY_DOWN]==1) {
			tempor=new AdaptiveMesh();
			tempor=cntrl->clone();
			*matModel=pmat.glInverse();
			for (c1=0;c1<cntrl->getNumVertices();c1++) {				
				memcpy(tvrt[0],tempor->getVertex(c1)->data,12);
				memcpy(tempor->getVertex(c1)->data,(*matModel*tvrt).data,12);
			}
			fselv=new array<int>(1,new int(cntrl->getNumVertices()),!currFlag);
			for (c1=0;c1<cntrl->getNumFaces();c1++)
				if (cself->data[c1]==currFlag)
					for (c2=0;c2<cntrl->getFace(c1)->length;c2++)
						fselv->data[cntrl->getFace(c1)->data[c2]]=1;
		}
		if (keys.data[KEY_GHOST]) {					
			for (c1=0;c1<cntrl->getNumVertices();c1++)
				if (!(cselv->data[c1]&OPT_PROT&&!keys.data['0'])&&fselv->data[c1]) {
					memcpy(tvrt[0],tempor->getVertex(c1)->data,12);
					memcpy(cntrl->getVertex(c1)->data,(pmat*tvrt).data,12);
				}
			dirtySubdiv=true;
		}
		if (keys.data[KEY_GHOST+KEY_DOWN]==-1) {delete tempor; delete fselv;}
		} break;
	case 3: //light
		glEnable(GL_LIGHT2);
		sprintf(glt,"...and let there be even more light.");
		linked_label.append(new glLabelText(10,frame_h-22,glt,fnt1));
		break;
	} //eo switch phantom layout
	
	//sprintf(glt,"%3i->%3i",currCarrier,currConnect); linked_label.append(new glLabelText(0,frame_h-44,glt,fnt1));

	//***
	sprintf(glt,"ui: %f",timer::singleton()->resetTime(0));
	linked_label.append(new glLabelText(0,frame_h-66,glt,fnt1));

	for (c1=0;c1<cntrl->getNumVertices();c1++) //YZ Projection=1
		if (cselv->data[c1]&OPT_YZPR) cntrl->getVertex(c1)->data[0]=0;

	//subdivision section----------------------------------------------------
	if (dirtySubdiv&&cntrl->getNumFaces()>0) {
		if (subdiv) {delete subdiv; subdiv=NULL;}		
		if (!mbar) {
			subdiv=new AdaptiveMesh();
			subdiv=cntrl->clone();
			addBoundary(true);
			Mesh *temp;		
			if (currDepth->token(0)) { //linear subdiv first
				temp=TetrahedralSubdivision::singleton()->linearSub(subdiv);
				delete subdiv;
				subdiv=temp;
			}
			for (c1=1;c1<currDepth->token(0);c1++) {
				temp=TetrahedralSubdivision::singleton()->subdivideMesh(subdiv);
				delete subdiv;
				subdiv=temp;
			}
			//***
			sprintf(glt,"subdiv: %f",timer::singleton()->resetTime(0));
			linked_label.append(new glLabelText(0,frame_h-77,glt,fnt1));
		} else {
			matrix<float> vsco(3,mbar->size[0],"");
				for (c1=0;c1<mbar->size[0];c1++) //has to be updated because of vert moving around
					memcpy(vsco[3*c1],cntrl->getVertex(c1)->data,12);
			matrix<float> dpos=mbrs->multMatSparse(vsco);			
			for (c1=0;c1<mbol->numel;c1++)				
				if (mbol->data[c1]) memcpy(&mact->data[10*c1+7],dpos[3*c1],12);						
			sprintf(glt,"matmult: %f",timer::singleton()->resetTime(0));
			linked_label.append(new glLabelText(0,frame_h-88,glt,fnt1));			
			dirtyNormals=true;
		}		
		dirtySubdiv=false;
	}
	if (keys.data[KEY_GHOST+KEY_DOWN]==-1&&dirtyNormals) {glAverageNormals(mact,mind,true);	dirtyNormals=false;	}
	

	
	//drawing grid and rest----------------------------------------------------
	drawMirrorAndUpdate();
	glEnable(GL_LIGHTING); drawVertices(); glDisable(GL_LIGHTING);

	glEnable(GL_BLEND);
	glDepthMask(GL_FALSE);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	drawMesh(cntrl);
	if (subdiv&&currDepth->token(0)) drawMesh(subdiv);
	//if (!currDepth->token(0)&&P->layout->size[1]!=3) drawMesh(cntrl); //no collision with linearSubdiv
	//if (subdiv) {
	//	cnt=currDepth->token(0);
	//	meshInfo(0,20,subdiv);
	//	//for (c1=0;c1<subdiv->getNumVertices();c1++) {sprintf(glt,"%i",c1);glCout.space(subdiv->getVertex(c1)->data,glt,fnt1);}
	//	if (cnt<6&&P->layout->size[1]!=3)
	//		if (quality) drawMeshSorted(subdiv); else drawMesh(subdiv);					
	//	//if (cnt==3) renderMesh(subdiv);
	//}
	
	sprintf(glt,"lev: %i - bary",currDepth->token(0)); linked_label.append(new glLabelText(0,42,glt,fnt1));
	if (mbar) sprintf(glt,"on"); else sprintf(glt,"off");	
	linked_label.append(new glLabelText(98,42,glt,fnt1));
	
	meshInfo(0,31,cntrl);
	
	//if (currDepth->token(0)>1) drawMesh(cntrl); //no collision with linearSubdiv
	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);

	//***
	sprintf(glt,"drwsub: %f",timer::singleton()->resetTime(0));
	linked_label.append(new glLabelText(0,frame_h-99,glt,fnt1));	

	//io funcs----------------------------------------------------
	if (keys.data['n'+KEY_DOWN]) {
		delete cntrl; cntrl=new AdaptiveMesh(); dirtySubdiv=true;
		if (jayaDeform) {
			*mact=*marr;
			if (mbar) {delete mbar; mbar=NULL;}
		}
		setDefaults();
		for (c1=0;c1<xmirror->numel;c1++) xmirror->data[c1]=-1;
		for (c1=0;c1<cselv->numel;c1++) cselv->data[c1]=0;		
	}
	if (keys.data['l'+KEY_DOWN]) {loadMesh(); dirtySubdiv=true;}
	if (keys.data['s']) {
		sprintf(glt,"save?"); 				 linked_label.append(new glLabelText(128,frame_h-66,glt,fnt1));
		sprintf(glt," \\- (c)ontrol"); linked_label.append(new glLabelText(128,frame_h-77,glt,fnt1));
		sprintf(glt," \\- (f)rame"); linked_label.append(new glLabelText(128,frame_h-88,glt,fnt1));
		sprintf(glt," \\- (t)riangular boundary"); linked_label.append(new glLabelText(128,frame_h-99,glt,fnt1));
		sprintf(glt," \\- (b)arycentrics"); linked_label.append(new glLabelText(128,frame_h-110,glt,fnt1));
		
		
		if (keys.data['c'+KEY_DOWN]) saveMesh(cntrl);
		if (keys.data['t'+KEY_DOWN]&&subdiv) exportTriangles(subdiv);
		if (keys.data['f'+KEY_DOWN]) {
			saveFrame();
			maxFrame=currFrame++;
		}
		if (keys.data['b'+KEY_DOWN]) {
			
		}
	} else {
		if (keys.data['b'+KEY_DOWN])
			if (mbar) {			
				delete mbar; mbar=NULL;
				delete mbrs; mbrs=NULL;
			} else
				if (subdiv&&jayaDeform) {
					baryModelQS(); currDepth->size[2]=0; dirtySubdiv=true;
					mbrs=new sparse<float>(*mbar);
				};		
	}

	
	if (keys.data['e'+KEY_DOWN]&&subdiv) {
		delete cntrl; cntrl=new AdaptiveMesh(); dirtySubdiv=true;
		MeshExplode(subdiv);
	}
	if (keys.data['v'+KEY_DOWN]) {
		shot_mode=!shot_mode;
		if (shot_mode) 
			for (c1=0;c1<mact->size[1];c1++) {
				mact->data[10*c1+0]=.97; mact->data[10*c1+1]=.53; mact->data[10*c1+2]=.3;
			}
		else
			for (c1=0;c1<mact->size[1];c1++)
				memcpy(&mact->data[c1*10],&marr->data[c1*10],12);		
	}
	if (keys.data['q'+KEY_DOWN]) {
		array<float> olok((*locat+".mlo").str);
		memcpy(A->mat->data,olok.data,16*4);
	}
	if (keys.data['i'+KEY_DOWN]) {interpol=!interpol; dirtySubdiv=true; }
};