#ifndef STRING_H
#define STRING_H

#include <string.h>
#include <iostream.h>

#define SEPR  "-------------------------------------------------------------------------------\n"
#define MAXIS 100

class string {
	public:
		string(void);										//construct:	null string
		string(const string& s);				//						copy
		string(char c[]);								//						from char
		~string(void);									//de-struct.
		string token(char *lim);				//						tokenizer		
		string braced(char *lim);
		string operator= (string& s);		//operators:
		void operator= (char c[]);
		string operator+ (string& s);
		string operator+ (char c[]);
		bool operator== (string& s);		//						stricmp
		bool operator== (char c[]);
		char *str;
		int len;
		char *pt;
};

string::string(void) {str=NULL; len=0; pt=NULL;}
string::string(const string& s) {
	if (s.str!=NULL) {
		len=s.len;
		str=new char[len+1];
		strcpy(str,s.str);
		pt=str; }
	else {len=0; str=NULL; pt=NULL; }
};
string::string(char c[]) {	
	len=strlen(c); str=new char[len+1];	strcpy(str,c); pt=str;
};
string::~string(void) {if (str) delete[] str; str=NULL;};
string string::token(char *lim) {	
	char *t;
	string s;	
	if (t=strtok(pt,lim)) {
		s=t;
		pt+=s.len+1;
		if (len!=pt-str-1) str[pt-str-1]=' '; }
	return s;
};
string string::braced(char *lim) {
	char *p1,*p2;
	string s;
	p1=strchr(str,lim[0]);  if (p1==NULL) return "";
	p2=strrchr(str,lim[1]); if (p2==NULL) return "";
	if (p1<p2) {
		s.len=p2-p1-1;
		s.str=new char[s.len+1];
		strncpy(s.str,p1+1,s.len);
		s.str[s.len]='\0';
		s.pt=s.str;
		return s;
	} else return "";
};

//operators-------------------------------------------------------
string string::operator= (string& s) {
	string a;
	if (str) delete[] str;
	len=s.len; str=new char[len+1]; strcpy(str,s.str); pt=str;
	if (a.str) delete[] a.str;
	a.len=s.len; a.str=new char[a.len+1]; strcpy(a.str,s.str); a.pt=a.str;
	return a;
};
void string::operator= (char c[]) {
	if (str) delete[] str;
	len=strlen(c); str=new char[len+1]; strcpy(str,c); pt=str;
};
string string::operator+ (string& s) {	
	string a;
	a.len=len+s.len; a.str=new char[a.len+1]; memcpy(a.str,str,len); strcpy(a.str+len,s.str); a.pt=a.str;
	return a;
};
string string::operator+ (char c[]) {	
	string a;
	a.len=len+strlen(c); a.str=new char[a.len+1]; memcpy(a.str,str,len); strcpy(a.str+len,c); a.pt=a.str;
	return a;
};
bool string::operator== (string& s) {return !stricmp(str,s.str);};
bool string::operator== (char c[]) {return !stricmp(str,c);};
ostream& operator<< (ostream& os, string& s);
istream& operator>> (istream& is, string& s);
ostream& operator<< (ostream& os, string& s) {
	if (s.str) os << s.str;	
	return os;
};
istream& operator>> (istream& is, string& s) {	
	char temp[MAXIS];
	is.getline(temp,MAXIS,'\n');
	s=temp;
	return is;
};

#endif